<?php
/*!
*******************************************************************************************************
* ATTENTION: THIS IS NOT FREE EDITION. FOR COMMERCIAL PURPOSES, PLEASE PURCHASE A COMMERCIAL LICENSE! *
*******************************************************************************************************
* File: Centcount Analytics Installation File                                                         *
* Version: 2.50                                                                                       *
* Author: WM Jonssen                                                                                  *
* Date: 03/20/2022                                                                                    *
* Copyright 2015-2022 WM Jonssen <wm.jonssen@gmail.com> - All rights reserved.                        *
* License: Dual licensed under the Free License and Commercial License.                               *
* Website: https://www.centcount.com                                                                  *
*******************************************************************************************************
*/
header('Content-type: text/html; charset=utf-8');
set_error_handler('ca_error');
function ca_error($type, $message, $file, $line) {
echo ('0<b>Error Type: ' . $type . ' => ' . $message . ' in ' . $file . ' on ' . $line . ' line .</b><br>');
}
$LANGUAGE = isset($_GET['lan']) ? $_GET['lan'] : 'en-US';
if ($LANGUAGE !== 'en-US' && $LANGUAGE !== 'zh-CN') $LANGUAGE = 'en-US';
$SUBDOMAIN = $LANGUAGE == 'en-US' ? 'www' : 'cn';
define('CA_VERSION', 2);
define('INSTALL_VERSION', '2.50.1.220320');
define('UPDATE_SERVER', 'up1.centcount.com, up2.centcount.com');
define('UPDATE_SERVER_MAIN', 'up1.centcount.com');
$IMAGE_URL = 'https://' . $SUBDOMAIN . '.centcount.com/images/install/';
$PURCHASE_URL = 'https://' . $SUBDOMAIN . '.centcount.com/pricing.php';
$SKIP_CONFIG = file_exists(__DIR__.'/config/config_setting.php') && file_exists(__DIR__.'/config/config_redis.php') ? 1 : 0;
if (file_exists(__DIR__.'/config/config_setting.php')) require_once __DIR__.'/config/config_setting.php';
if (isset($_GET['opt']) && (int)$_GET['opt'] > 3) {
require_once __DIR__.'/config/config_redis.php';
if (!defined('REDIS_AUTH')) define('REDIS_AUTH', '');
$REDIS_INSTALL = new Redis();
if ($REDIS_INSTALL->CONNECT(REDIS_IP_0, REDIS_PORT_0) !== true) exit('0');
if (REDIS_AUTH) $REDIS_INSTALL->AUTH(REDIS_AUTH);
$REDIS_INSTALL->SELECT(REDIS_DB_0);
switch ((int)$_GET['opt']) {
case 4:
$prog = $REDIS_INSTALL->GET('INSTALL_PROGRESS');
$stat = $REDIS_INSTALL->GET('INSTALL_STATUS');
if ($prog && $stat) exit('1'.$prog.$stat);
exit('0');
case 5:
$log = $REDIS_INSTALL->GET('INSTALL_LOG');
$REDIS_INSTALL->DEL('INSTALL_PROGRESS', 'INSTALL_STATUS', 'INSTALL_LOG');
if ($log) exit('1'.$log);
exit('0');
case 6:
if (unlink('install.php')) {
if ($LANGUAGE == 'en-US') {
exit('1Centcount Analytics has been installed successfully, and the installation file has been also deleted.');
} else {
exit('1百夫长统计已安装成功，出于安全考虑我们已自动删除了安装程序文件。');
}
} else {
if ($LANGUAGE == 'en-US') {
exit('0Centcount Analytics has been installed successfully, but delete Centcount Analytics installation file failed. FOR SECURITY PLEASE DETELE MANUALLY!');
} else {
exit('1百夫长统计已安装成功，但是删除安装程序文件时出错了，处于安全考虑我们强烈建议您手动删除安装文件。');
}
}
}
}
$KEEP_INSTALL = 0;
if (file_exists(__DIR__.'/config/config_redis.php')) {
require_once __DIR__.'/config/config_redis.php';
if (!defined('REDIS_AUTH')) define('REDIS_AUTH', '');
$REDIS_INSTALL = new Redis();
if ($REDIS_INSTALL->CONNECT(REDIS_IP_0, REDIS_PORT_0) == true) {
if (REDIS_AUTH) $REDIS_INSTALL->AUTH(REDIS_AUTH);
$REDIS_INSTALL->SELECT(REDIS_DB_0);
$KEEP_INSTALL = $REDIS_INSTALL->EXISTS('INSTALL_STATUS');
$KEEP_INSTALL = $KEEP_INSTALL ? 1 : 0;
}
}
$AGREEMENT = array(
'en-US' => '
<p>
<b>Please read this agreement carefully before installing and using our software.</b><br><br>
Copyright &copy; 2015-'.date('Y').', WM Jonssen.<br>
All Rights Reserved.<br><br>
This software license agreement (hereinafter the “Agreement”) is a legal agreement between the user (hereinafter “You” or the “User”) and Author/Owner of Centcount Analytics (hereinafter “Author”) for the software products (hereinafter the “Software”) and related services (hereinafter the “Service”) that accompanies this Agreement, as may be updated or replaced by feature enhancements, software updates or maintenance releases and any services that may be provided by Author under this Agreement. You are not allowed to download, install or use the Software or to use Services unless you accept all the terms and conditions of this Agreement. Your download, installation and use of the Software shall be regarded as your acceptance of the Agreement and your agreement to be bound by all the terms and conditions of this Agreement.<br><br>
This Agreement, between the User and Author, is an agreement regarding the User\'s downloading, installation, use and copying of the Software, and the use of Services provided by Author. This Agreement stipulates the rights and duties of You and Author regarding the licensed use and related services. "The User" or "You" refers to a person (who is 18 years of age or older, any parent or guardian of a person under the age of 18 may accept this Agreement on behalf of a user) or entity who obtains the Software authorization license and/or the Software products by means of the Software license and the account registration as provided by Author.<br><br>
This Agreement may be updated by Author at any time and without prior notice to the User. After the updated Agreement is issued, it shall replace the original Agreement effectively. Users can read the updated Agreement by logging in the Software or checking on the Website at any time. After Author has updated the clauses of Agreement, the User should stop using software and services provided by Author if he/she does not agree with the clauses amended, otherwise it will be deemed that the user has accepted the Agreement as amended.<br><br>
Except those explicitly stated in the Agreement, the Agreement does not stipulate the terms of service for other services offered by Author which the User visits when using the “Software”. Those services are usually regulated by other separate terms of service and the User should be familiar with and confirm his/her acceptance of those terms of service when using the relevant services. If there are conflicts between separate terms of service and this Agreement, the separate terms of service will govern. By using those services, the User shall be regarded as having accepted the relevant terms of service.<br><br>
<b>1. Grant of License</b><br>
Subject to the terms and conditions of this Agreement, Author grants to you a limited, non-exclusive, worldwide license to install, download and use a single instance of the Software on a single website server through a single installation for non-commercial purposes for free.<br><br>
You can modify the source code (if being provided) or interface of the Software if your modification is strictly under the Agreement and to beautify your website.<br><br>
When using the Software, the User shall comply with the relevant national laws and policies, protect the national interests, safeguard the national security and comply with this Agreement. The User, but not Author, shall be fully responsible for all liabilities resulting from the illegal use of the Software or breach of the Agreement. If the User\'s misbehavior causes loss to Author, Author is entitled to demand the User to provide compensation, cease provision of the service immediately and keep relevant records. Moreover, if the User violates laws or the Agreement and correlative clauses of services stipulated in other services of Author by using the Software, Author has the right to take these measures including, but not limited to, interruption of use license, stopping of services, restriction of use, legal investigation, etc. considering the nature of the User’s behaviors and without a prior notice to the User.<br><br>
You have the entire property of all the members’ data, information and articles in your website which is powered by the Software; that is to say, you must assume solely all the relevant liabilities concerns to the contents in your website.<br><br>
You may use the Software for commercial means after purchase of the commercial license. Moreover, according to the license you purchase you will get technical support from Author in specified term and manner. Commercial users are prior to submitting ideas and opinions to Author, but without any guarantee of acceptance.<br><br>
You can download application(s) for your website from Centcount Analytics official website after you have paid appropriate fee to the author/owner of the application(s).<br><br>
<b>2. License Restrictions</b><br>
You cannot use the Software for commercial or profit purposes (include but are not limited to company websites, operating websites or other for-profit websites) unless you have been licensed to. To purchase the license, please visit <a href="https://www.centcount.com/pricing.php">https://www.centcount.com/pricing.php</a> or email to wm.jonssen@gmail.com for more information.<br><br>
You may not rent, sublicense, assign, lease, loan, resell, distribute, publish or network the Software or related materials or create derivative works based upon the Software or any part thereof.<br><br>
You may not use the Software to engage in or allow others to engage in any illegal activity. You may not use the Software to engage in any activity that will violate the rights of third parties, including, without limitation, copyrights, trademarks, publicity rights, privacy rights, other proprietary rights, or rights against defamation of third parties.<br><br>
You cannot remove or modify the copyright information and relevant links under any circumstances, such as <a href="https://www.centcount.com">https://www.centcount.com</a>, in the foot of web pages without the prior written consent of Author.<br><br>
You cannot reverse engineer, decompile or disassemble, copy, modify, link, reproduce, publish or develop derivative products of the applications that you download from Centcount Analytics official website without the prior written permission from the application author/owner.<br><br>
<b>3. Disclaimer of Warranties and Limitations of Liabilities</b><br>
The software and the accompanying files are provided “as-is”, and to the maximum extent permitted by applicable law, Author disclaims all other warranties, express or implied, by statute or otherwise, regarding the software and any related materials, including their fitness for a particular purpose, their quality, their merchantability, or any related services or content is secure, or is free from bugs, viruses, errors, or other program limitations nor does it warrant access to the internet or to any other services through the software.<br><br>
To the maximum extent permitted by applicable law, Author will not be liable for any indirect, special, incidental, or consequential damages(including damages for loss of business, loss of profits, or the like), whatever based on breach of contract, tort(including negligence), product liability or otherwise, even Author has been advised of the possibility of such damages. Author’ total liability to you for actual damages for any cause whatsoever will be limited to the purchase price amount paid by you for the software.<br><br>
Author is not liable for the content of any message in the websites powered by the Software.<br><br>
Author does not guarantee the legality, safety, integrity, authenticity and quality of the applications which uploaded into Centcount Analytics official website by any third party. You agree to judge on yourself and take fully responsibilities to the action of download from Centcount Analytics official website. But in any case, Author may stop the Store’s service and take appropriate actions, including but not limited to uninstall the associated applications, suspend the Store’s service in whole or in part, keep the relevant records to the relevant authorities, and Author will not undertake any direct, indirect or consequential liability to the actions thereof.<br><br>
<b>4. Termination</b><br>
The License is effective until terminated. You may terminate the License at any time by uninstalling the Software and destroying all copies of the Software in any media. This Agreement may be terminated by Author immediately and without notice if you fail to comply with any term or condition of the License or this Agreement. Upon such termination, you must immediately cease using the Software, and assume relevant liabilities.<br><br>
Author reserves the right to change or add to the terms of this Agreement at any time (including but are not limited to Internet-based Solutions, pricing, technical support options, and other product-related policies), and to change, discontinue or impose conditions on any feature or aspect of the Software, or any Internet-based Solutions provided to you or made available to you in the official websites. Such changes will be effective upon notification by any means reasonable to give you actual or constructive notice including by posting such terms on the discuz.net website, or another website designated by Author. Your continued use of the Software will indicate your agreement to any such change.<br><br>
<b>5. Controlling Law</b><br>
The Agreement is governed by and construed in accordance with the laws of P.R China. You hereby consent to the exclusive jurisdiction and venue in the HuiShan District court of the City of Wuxi.<br><br>
</p>
<p style="text-align:right;">
Author/Owner: WM Jonssen<br>
05/04/2019
</p>',
'zh-CN' => '
<p>
<b>在安装和使用本软件之前请仔细阅读本协议。</b><br/><br/>
版权所有 &copy; 2015-'.date('Y').'，WM Jonssen 保留所有权利。<br/><br/>
<b>用户须知：</b>本协议是您与软件作者之间关于您使用软件作者提供的各种软件产品及服务的法律协议。无论您是个人或组织、盈利与否、用途如何（包括以学习和研究为目的），均需仔细阅读本协议，包括免除或者限制软件作者责任的免责条款及对您的权利限制。请您审阅并接受或不接受本服务条款。如您不同意本服务条款及/或软件作者随时对其的修改，您应不使用或主动取消软件作者提供的百夫长统计产品。否则，您的任何对百夫长统计产品中的相关服务的注册、登陆、下载、查看等使用行为将被视为您对本服务条款全部的完全接受，包括接受软件作者对服务条款随时所做的任何修改。
本服务条款一旦发生变更, 软件作者将在网页上公布修改内容。修改后的服务条款一旦在网站管理后台上公布即有效代替原来的服务条款。您可随时登陆百夫长统计官方网站查阅最新版服务条款。如果您选择接受本条款，即表示您同意接受协议各项条件的约束。如果您不同意本服务条款，则不能获得使用本服务的权利。您若有违反本条款规定，软件作者有权随时中止或终止您对百夫长统计产品的使用资格并保留追究相关法律责任的权利。
在理解、同意、并遵守本协议的全部条款后，方可开始使用百夫长统计产品。您可能与软件作者直接签订另一书面协议，以补充或者取代本协议的全部或者任何部分。<br/><br/>
软件作者拥有本软件的全部知识产权。本软件只供许可协议，并非出售。软件作者只允许您在遵守本协议各项条款的情况下复制、下载、安装、使用或者以其他方式受益于本软件的功能或者知识产权。<br/><br/>
<b>I. 协议许可的权利</b><br/><br/>
1. 您可以在完全遵守本许可协议的基础上，将本软件应用于非商业用途，而不必支付软件版权许可费用。<br/>
2. 您可以在协议规定的约束和限制范围内修改百夫长统计产品源代码(如果被提供的话)或界面风格以适应您的网站要求。<br/>
3. 您拥有使用本软件构建的网站中全部会员资料、文章及相关信息的所有权，并独立承担与使用本软件构建的网站内容的审核、注意义务，确保其不侵犯任何人的合法权益，独立承担因使用百夫长统计软件和服务带来的全部责任，若造成软件作者或用户损失的，您应予以全部赔偿。<br/>
4. 若您需将百夫长统计软件或服务用户商业用途，必须另行获得软件作者的书面许可，您在获得商业授权之后，您可以将本软件应用于商业用途，同时依据所购买的授权类型中确定的技术支持期限、技术支持方式和技术支持内容，自购买时刻起，在技术支持期限内拥有通过指定的方式获得指定范围内的技术支持服务。商业授权用户享有反映和提出意见的权力，相关意见将被作为首要考虑，但没有一定被采纳的承诺或保证。<br/>
5. 您可以从软件作者提供的应用中心服务中下载适合您网站的第三方插件或扩展程序，但应向第三方程序开发者/所有者支付相应的费用。<br/><br/>
<b>II. 协议规定的约束和限制</b><br/><br/>
1. 未获软件作者书面商业授权之前，不得将本软件用于商业用途（包括但不限于企业网站、经营性网站、以营利为目或实现盈利的网站）。购买商业授权请登陆 <a href="https://www.centcount.com/pricing.php">https://www.centcount.com/pricing.php</a> 参考相关说明，了解详情。<br/>
2. 不得对本软件或与之关联的商业授权进行出租、出售、抵押或发放子许可证。<br/>
3. 无论如何，即无论用途如何、是否经过修改或美化、修改程度如何，只要使用百夫长统计产品的整体或任何部分，未经书面许可，页面页脚处的百夫长统计产品名称和软件作者下属网站（<a href="https://www.centcount.com">https://www.centcount.com</a>） 的链接都必须保留，而不能清除或修改。<br/>
4. 禁止在百夫长统计产品的整体或任何部分基础上以发展任何派生版本、修改版本或第三方版本用于重新分发。<br/>
5. 您从应用中心下载的应用程序，未经应用程序开发者/所有者的书面许可，不得对其进行反向工程、反向汇编、反向编译等，不得擅自复制、修改、链接、转载、汇编、发表、出版、发展与之有关的衍生产品、作品等。<br/>
6. 如果您未能遵守本协议的条款，您的授权将被终止，所许可的权利将被收回，同时您应承担相应法律责任。<br/><br/>
<b>III. 有限担保和免责声明</b><br/><br/>
1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的。<br/>
2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未购买产品技术服务之前，我们不承诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任。<br/>
3. 软件作者不对使用本软件构建的网站中的文章或信息承担责任，全部责任由您自行承担。<br/>
4. 软件作者无法全面监控由第三方上传至应用中心的应用程序，因此不保证应用程序的合法性、安全性、完整性、真实性或品质等；您从应用中心下载应用程序时，同意自行判断并承担所有风险，而不依赖于软件作者。但在任何情况下，软件作者有权依法停止应用中心服务并采取相应行动，包括但不限于对于相关应用程序进行卸载，暂停服务的全部或部分，保存有关记录，并向有关机关报告。由此对您及第三人可能造成的损失，软件作者不承担任何直接、间接或者连带的责任。<br/>
5. 软件作者对提供的软件和服务之及时性、安全性、准确性不作担保，由于不可抗力因素、软件作者无法控制的因素（包括黑客攻击、停断电等）等造成软件使用和服务中止或终止，而给您造成损失的，您同意放弃追究软件作者责任的全部权利。<br/>
6. 软件作者特别提请您注意，软件作者为了保障业务发展和调整的自主权，软件作者拥有随时经或未经事先通知而修改服务内容、中止或终止部分或全部软件使用和服务的权利，修改会公布于软件作者网站相关页面上，一经公布视为通知。软件作者行使修改或中止、终止部分或全部软件使用和服务的权利而造成损失的，软件作者不需对您或任何第三方负责。<br/><br/>
有关百夫长统计产品最终用户授权协议、商业授权与技术服务的详细内容，均由软件作者独家提供。软件作者拥有在不事先通知的情况下，修改授权协议和服务价目表的权利，修改后的协议或价目表对自改变之日起的新授权用户生效。<br/><br/>
一旦您开始安装百夫长统计产品，即被视为完全理解并接受本协议的各项条款，在享有上述条款授予的权利的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。<br/><br/>
本许可协议条款的解释，效力及纠纷的解决，适用于中华人民共和国大陆法律。<br/><br/>
若您和软件作者之间发生任何纠纷或争议，首先应友好协商解决，协商不成的，您在此完全同意将纠纷或争议提交软件作者所在地无锡市惠山区人民法院管辖。软件作者拥有对以上各项条款内容的解释权及修改权。（正文完）<br/><br/>
</p>
<p style="text-align:right;">
软件作者：WM Jonssen<br>
2019-05-04
</p>');
$INSTALL_LANGUAGE = array(
'en-US' => array(
'CA' => 'Centcount Analytics',
'PageTitle' => 'Centcount Analytics Installation', 
'Agreement' => 'Centcount Analytics Agreement', 
'Accept' => 'I ACCEPT',
'Environment' => 'Check Server Environment', 
'CheckAgain' => 'CHECK AGAIN', 
'NextStep' => 'NEXT STEP', 
'PreStep' => 'PREVIOUS STEP',
'EnvReady' => 'Server environment is ready now!',
'Configuration' => 'CONFIGURATION',
'AdminLoginEmail' => 'Administrator Login Email:',
'AdminLoginPW' => 'Administrator Login Password:',
'AdminTimezone' => 'Admin Timezone (Default: GMT+08:00/Beijing):',
'DatabaseHost' => 'Database Host (Default: 127.0.0.1):',
'DatabaseRoot' => 'Database Root Username (Default: root):',
'DatabaseRootPW' => 'Database Root Password:',
'RedisAuth' => 'Redis Password:',
'EncodeFactor' => 'Encode Factor (GENERATED BY SYSTEM):',
'DomainName' => 'Domain Name (e.g: example.com:8080):',
'HostName' => 'Server Host Name (e.g: Centcount-Analytics-Host):',
'HostModel' => 'Server Host Model (Default: MASTER):',
'MailService' => 'Mail Service (Default: CA Free Mail Service):',
'AutoUpdate' => 'Auto Update (Default: On):',
'cURLProtocol' => 'cURL Protocol (Default: HTTPS):',
'AlreadyConfigured' => 'ALREADY CONFIGURED, SKIP',
'Configure' => 'CONFIGURE',
'CheckConfig' => 'Check Configuration',
'ConfigReady' => 'It is ready for installing Centcount Analytics now!',
'Authorization' => 'AUTHORIZATION',
'AccountEmail' => 'Account Email:',
'AccountID' => 'Account ID:',
'LicenseKey' => 'License Key:',
'AuthorityTip' => '*License key is required while installing Centcount Analytics. If you don\'t have license key yet, You can purchase a license online right now. We accept PayPal. Or you can apply a trial account to feel free for 15 days.',
'Authorize' => 'AUTHORIZE NOW',
'ApplyTrialKey' => 'APPLY 15-DAY TRIAL',
'Purchase' => 'PURCHASE A LICENSE',
'AlreadyAuthorized' => 'ALREADY AUTHORIZED, SKIP',
'Install' => 'INSTALL NOW',
'InstallLog' => 'Installation Log',
'SignIn' => 'SIGN IN',
'Reinstall' => 'REINSTALL',
'Reconfigure' => 'RECONFIGURE',
'Privacy0' => 'Data Security &amp; Privacy',
'Privacy1' => 'Self-Hosted, 100% Data Ownership',
'Privacy2' => 'What is the most important thing to you on internet? Absolute data security &amp; privacy! Commercial data in particular. Unfortunately, There is nothing can be trust on internet, including third party services. So, If you want data security, You have to hold 100% data ownership. Centcount Analytics is an open-source web analytics software. It can be deployed easily on your own server, 100% data ownership.',
'Introduction0' => 'What Is Centcount Analytics?',
'Introduction1' => 'A Powerful Tools Combination.',
'Introduction2' => '1. Provides up to 37 fixed reports of various dimensions, real-time visitor data, and advanced analysis tools such as heatmap, mouse tracking and custom report.<br>
2. The unique page heartbeat technology allows you to accurately record the single page duration time. We also do the functions that others do not do, only for the needs of users.<br>
3. In-depth tracking of visitor reading behavior, whether it is page reading depth or depth of visit. Let you understand the page experience and visitor\'s reading habits.<br>
4. The powerful Fire-Eye technology, let you know a lot of fake network traffic. We have our own standard of data identification. Whether it is spiders, robots, or traffic fraud will be detected easily.<br>
5. The technology based on global listening has achieved tools such as heatmap. But the pursuit of technology should not exceed the moral bottom line. We will continue to stick to the bottom line and never do evil.',
'Heatmap0' => 'Heatmap',
'Heatmap1' => 'What You See Is What You Get.',
'Heatmap2' => 'A new &amp; direct way to show the visitor\'s clicks on your page. Based on the advanced positioning technology of page element, the Centcount Analytics heatmap perfectly supports the adaptive page, combined with rich data filtering functions, to present a different data view as your wish.',
'GodView0' => 'God View (Mouse Tracking)',
'GodView1' => 'Behavior Tell You The Truth',
'GodView2' => 'Centcount Analytics records every visitor\'s mouse tracks, Analyzes those actions to get visitor\'s real thought &amp; dig out hidden page errors. In some cases, heatmap is not enough to explain everything. By using God View to examine each visitor\'s browsing behavior. Through fetching visitor behavior data to modify page to more conform to people\'s browsing habits, find out unknown page errors, insight into visitor\'s intentions.',
'Report0' => 'Custom Report',
'Report1' => 'Play Data In Any Possible Ways.',
'Report2' => 'Multi-Dimension,<br>
Multi-Condition,<br>
Multi-Metric,<br>
Return data with grouped and sorted. Get the data what you want without any limitation, because all of the data is yours.',
'Security0' => 'Program Security',
'Security1' => 'Independent Intellectual Property Rights, Safe &amp; Controllable',
'Security2' => 'The programs are all written with native programming language and do not use any third-party libraries or frameworks. The procedural programming style ensures program execution efficiency while ensuring that every line of code is understandable and controllable. The reason for not using third-party libraries and frameworks is that we can\'t understand them thoroughly, and how to ensure security for things you don\'t understand. Therefore, we advocate to reinvent the wheel, and this is the only way to have independent intellectual property rights, so that there is real security.'
),
'zh-CN' => array(
'CA' => '百夫长统计',
'PageTitle' => '百夫长统计安装向导', 
'Agreement' => '百夫长统计使用协议', 
'Accept' => '我接受',
'Environment' => '检查服务器安装环境', 
'CheckAgain' => '重新检查', 
'NextStep' => '下一步', 
'PreStep' => '上一步',
'EnvReady' => '服务器安装环境已准备就绪！',
'Configuration' => '配置参数',
'AdminLoginEmail' => '管理员登录邮箱：',
'AdminLoginPW' => '管理员登录密码：',
'AdminTimezone' => '管理员时区 (默认: GMT+08:00/Beijing):',
'DatabaseHost' => '数据库主机 (默认: 127.0.0.1):',
'DatabaseRoot' => '数据库ROOT用户名 (默认: root):',
'DatabaseRootPW' => '数据库ROOT密码：',
'RedisAuth' => 'REDIS密码：',
'EncodeFactor' => '私有加密因子 (由系统自动生成):',
'DomainName' => '统计站域名 (如: example.com:8080):',
'HostName' => '服务器主机名 (如: Centcount-Analytics-Host):',
'HostModel' => '主机受控模式 (默认: MASTER):',
'MailService' => '邮件服务 (默认: CA Free Mail Service):',
'AutoUpdate' => '自动更新 (默认: On):',
'cURLProtocol' => 'cURL协议 (默认: HTTPS):',
'AlreadyConfigured' => '已配置，跳过',
'Configure' => '配置',
'CheckConfig' => '检查配置',
'ConfigReady' => '安装百夫长统计准备工作已就绪！',
'Authorization' => '授权',
'AccountEmail' => '支付账户邮箱:',
'AccountID' => '支付账户ID:',
'LicenseKey' => '授权KEY:',
'AuthorityTip' => '*百夫长统计在安装过程中需要在线激活，如果您尚未购买百夫长统计授权KEY，你可以点击下方购买按钮立即购买，我们接受支付宝、微信和PAYPAL的付款。或者申请一个15天免费试用账户。',
'Authorize' => '立即授权',
'ApplyTrialKey' => '申请15天试用',
'Purchase' => '购买授权KEY',
'AlreadyAuthorized' => '已授权，跳过',
'Install' => '立即安装',
'InstallLog' => '安装日志',
'SignIn' => '登录',
'Reinstall' => '重新安装',
'Reconfigure' => '重新配置',
'Privacy0' => '数据安全和隐私',
'Privacy1' => '自部署，100%数据私有',
'Privacy2' => '在互联网上对你来说最重要的是什么？绝对是数据安全和隐私，特别是商业数据。遗憾的是互联网上没有任何可以信任的东西，包括第三方服务。所以如果你想要数据安全和隐私，你必须拥有100%的数据所有权。百夫长统计是一款免费开源的网站统计分析软件。它可以很容易地部署到您自己的服务器上，100%独享数据。',
'Introduction0' => '什么是百夫长统计？',
'Introduction1' => '一个强大的工具组合',
'Introduction2' => '一、提供多达37种各种维度的统计分析报告，实时访客数据，并且提供自定义报告，热力图和上帝视图等高级分析工具。<br>
二、独有的百夫长页面心跳技术，让你精准的记录单页面停留时间。别人不做的功能我们也做，只为用户的需求。<br>
三、深入追踪访客阅读行为，不论是页面阅读深度还是访问深度，让你深入了解网站的页面体验和访客的阅读喜好。<br>
四、强大的百夫长火眼技术，让深谙各种网络流量作弊行为的我们对数据的鉴别自有一套，不论是蜘蛛、爬虫、还是伪造流量都难逃火眼。<br>
五、基于全局监听的无埋点技术成就了热力图等工具，但是对技术的追求不应逾越道德底线，我们将继续坚守底线绝不作恶。',
'Heatmap0' => '热力图',
'Heatmap1' => '所见即所得',
'Heatmap2' => '一种全新的，更直观的方式展现访问者在您网页上的浏览行为！由于采用先进的页面元素级定位技术，使得百夫长热力图完美支持自适应页面，加之丰富的数据过滤功能，如你所愿得呈现别无二致的数据视图。',
'GodView0' => '上帝视图（鼠标轨迹追踪）',
'GodView1' => '通过行为解读意图',
'GodView2' => '百夫长统计能够完整得记录每个访客的浏览轨迹，通过访客浏览轨迹来解读其背后的真实意图和发现页面隐藏的问题。某些情况下仅仅依靠热力图不足以说明一切，站在上帝的角度审视每一个访客的浏览行为，让你的页面更符合大众的浏览习惯，发现未知页面错误，洞悉访客意图。',
'Report0' => '自定义报告',
'Report1' => '随心所欲的玩转数据',
'Report2' => '抽丝剥茧，取其精要，轻松玩转数据分析！<br>
多维度，<br>
多条件，<br>
多指标，<br>
并按分组和排序查询你想要的数据，毫无限制的使用数据库，因为一切都是你的。',
'Security0' => '程序安全',
'Security1' => '自主知识产权，安全可控',
'Security2' => '程序全部采用原生语言编写，没有使用任何第三方库或框架。过程化编程风格确保程序执行效率的同时确保每一行代码都是可以理解的和可控的。对于没有使用第三方库和框架的原因也正是我们无法深入透彻了解它们，对于自己不了解的东西你又如何保证安全。所以我们倡导重复造轮子，唯有这样才能拥有自主知识产权，才有真正的安全。'
)
);
$IPDBS = array(
'IP2LOCATION (English)',
'GeoIP (简体中文)',
'GeoIP (English)'
);
$TIMEZONES = array(
'(GMT-12:00) International Date Line West' => 'Pacific/Kwajalein',
'(GMT-11:00) Midway Island' => 'Pacific/Midway',
'(GMT-11:00) Samoa' => 'Pacific/Apia',
'(GMT-10:00) Hawaii' => 'Pacific/Honolulu',
'(GMT-09:00) Alaska' => 'America/Anchorage',
'(GMT-08:00) Pacific Time (US & Canada)' => 'America/Los_Angeles',
'(GMT-08:00) Tijuana' => 'America/Tijuana',
'(GMT-07:00) Arizona' => 'America/Phoenix',
'(GMT-07:00) Mountain Time (US & Canada)' => 'America/Denver',
'(GMT-07:00) Chihuahua' => 'America/Chihuahua',
'(GMT-07:00) La Paz' => 'America/Chihuahua',
'(GMT-07:00) Mazatlan' => 'America/Mazatlan',
'(GMT-06:00) Central Time (US & Canada)' => 'America/Chicago',
'(GMT-06:00) Central America' => 'America/Managua',
'(GMT-06:00) Guadalajara' => 'America/Mexico_City',
'(GMT-06:00) Mexico City' => 'America/Mexico_City',
'(GMT-06:00) Monterrey' => 'America/Monterrey',
'(GMT-06:00) Saskatchewan' => 'America/Regina',
'(GMT-05:00) Eastern Time (US & Canada)' => 'America/New_York',
'(GMT-05:00) Indiana (East)' => 'America/Indiana/Indianapolis',
'(GMT-05:00) Bogota' => 'America/Bogota',
'(GMT-05:00) Lima' => 'America/Lima',
'(GMT-05:00) Quito' => 'America/Bogota',
'(GMT-04:00) Atlantic Time (Canada)' => 'America/Halifax',
'(GMT-04:00) Caracas' => 'America/Caracas',
'(GMT-04:00) La Paz' => 'America/La_Paz',
'(GMT-04:00) Santiago' => 'America/Santiago',
'(GMT-03:30) Newfoundland' => 'America/St_Johns',
'(GMT-03:00) Brasilia' => 'America/Sao_Paulo',
'(GMT-03:00) Buenos Aires' => 'America/Argentina/Buenos_Aires',
'(GMT-03:00) Georgetown' => 'America/Argentina/Buenos_Aires',
'(GMT-03:00) Greenland' => 'America/Godthab',
'(GMT-02:00) Mid-Atlantic' => 'America/Noronha',
'(GMT-01:00) Azores' => 'Atlantic/Azores',
'(GMT-01:00) Cape Verde Is.' => 'Atlantic/Cape_Verde',
'(GMT) Casablanca' => 'Africa/Casablanca',
'(GMT) Dublin' => 'Europe/London',
'(GMT) Edinburgh' => 'Europe/London',
'(GMT) Lisbon' => 'Europe/Lisbon',
'(GMT) London' => 'Europe/London',
'(GMT) Monrovia' => 'Africa/Monrovia',
'(GMT+01:00) Amsterdam' => 'Europe/Amsterdam',
'(GMT+01:00) Belgrade' => 'Europe/Belgrade',
'(GMT+01:00) Berlin' => 'Europe/Berlin',
'(GMT+01:00) Bern' => 'Europe/Berlin',
'(GMT+01:00) Bratislava' => 'Europe/Bratislava',
'(GMT+01:00) Brussels' => 'Europe/Brussels',
'(GMT+01:00) Budapest' => 'Europe/Budapest',
'(GMT+01:00) Copenhagen' => 'Europe/Copenhagen',
'(GMT+01:00) Ljubljana' => 'Europe/Ljubljana',
'(GMT+01:00) Madrid' => 'Europe/Madrid',
'(GMT+01:00) Paris' => 'Europe/Paris',
'(GMT+01:00) Prague' => 'Europe/Prague',
'(GMT+01:00) Rome' => 'Europe/Rome',
'(GMT+01:00) Sarajevo' => 'Europe/Sarajevo',
'(GMT+01:00) Skopje' => 'Europe/Skopje',
'(GMT+01:00) Stockholm' => 'Europe/Stockholm',
'(GMT+01:00) Vienna' => 'Europe/Vienna',
'(GMT+01:00) Warsaw' => 'Europe/Warsaw',
'(GMT+01:00) West Central Africa' => 'Africa/Lagos',
'(GMT+01:00) Zagreb' => 'Europe/Zagreb',
'(GMT+02:00) Athens' => 'Europe/Athens',
'(GMT+02:00) Bucharest' => 'Europe/Bucharest',
'(GMT+02:00) Cairo' => 'Africa/Cairo',
'(GMT+02:00) Harare' => 'Africa/Harare',
'(GMT+02:00) Helsinki' => 'Europe/Helsinki',
'(GMT+02:00) Istanbul' => 'Europe/Istanbul',
'(GMT+02:00) Jerusalem' => 'Asia/Jerusalem',
'(GMT+02:00) Kyev' => 'Europe/Kiev',
'(GMT+02:00) Minsk' => 'Europe/Minsk',
'(GMT+02:00) Pretoria' => 'Africa/Johannesburg',
'(GMT+02:00) Riga' => 'Europe/Riga',
'(GMT+02:00) Sofia' => 'Europe/Sofia',
'(GMT+02:00) Tallinn' => 'Europe/Tallinn',
'(GMT+02:00) Vilnius' => 'Europe/Vilnius',
'(GMT+03:00) Baghdad' => 'Asia/Baghdad',
'(GMT+03:00) Kuwait' => 'Asia/Kuwait',
'(GMT+03:00) Moscow' => 'Europe/Moscow',
'(GMT+03:00) Nairobi' => 'Africa/Nairobi',
'(GMT+03:00) Riyadh' => 'Asia/Riyadh',
'(GMT+03:00) St. Petersburg' => 'Europe/Moscow',
'(GMT+03:00) Volgograd' => 'Europe/Volgograd',
'(GMT+03:30) Tehran' => 'Asia/Tehran',
'(GMT+04:00) Abu Dhabi' => 'Asia/Muscat',
'(GMT+04:00) Baku' => 'Asia/Baku',
'(GMT+04:00) Muscat' => 'Asia/Muscat',
'(GMT+04:00) Tbilisi' => 'Asia/Tbilisi',
'(GMT+04:00) Yerevan' => 'Asia/Yerevan',
'(GMT+04:30) Kabul' => 'Asia/Kabul',
'(GMT+05:00) Ekaterinburg' => 'Asia/Yekaterinburg',
'(GMT+05:00) Islamabad' => 'Asia/Karachi',
'(GMT+05:00) Karachi' => 'Asia/Karachi',
'(GMT+05:00) Tashkent' => 'Asia/Tashkent',
'(GMT+05:30) Chennai' => 'Asia/Kolkata',
'(GMT+05:30) Kolkata' => 'Asia/Kolkata',
'(GMT+05:30) Mumbai' => 'Asia/Kolkata',
'(GMT+05:30) New Delhi' => 'Asia/Kolkata',
'(GMT+05:45) Kathmandu' => 'Asia/Kathmandu',
'(GMT+06:00) Almaty' => 'Asia/Almaty',
'(GMT+06:00) Astana' => 'Asia/Dhaka',
'(GMT+06:00) Dhaka' => 'Asia/Dhaka',
'(GMT+06:00) Novosibirsk' => 'Asia/Novosibirsk',
'(GMT+06:00) Sri Jayawardenepura' => 'Asia/Colombo',
'(GMT+06:30) Rangoon' => 'Asia/Rangoon',
'(GMT+07:00) Bangkok' => 'Asia/Bangkok',
'(GMT+07:00) Hanoi' => 'Asia/Bangkok',
'(GMT+07:00) Jakarta' => 'Asia/Jakarta',
'(GMT+07:00) Krasnoyarsk' => 'Asia/Krasnoyarsk',
'(GMT+08:00) Beijing' => 'Asia/Shanghai',
'(GMT+08:00) Shanghai' => 'Asia/Shanghai',
'(GMT+08:00) Chongqing' => 'Asia/Chongqing',
'(GMT+08:00) Hong Kong' => 'Asia/Hong_Kong',
'(GMT+08:00) Irkutsk' => 'Asia/Irkutsk',
'(GMT+08:00) Kuala Lumpur' => 'Asia/Kuala_Lumpur',
'(GMT+08:00) Perth' => 'Australia/Perth',
'(GMT+08:00) Singapore' => 'Asia/Singapore',
'(GMT+08:00) Taipei' => 'Asia/Taipei',
'(GMT+08:00) Ulaan Bataar' => 'Asia/Irkutsk',
'(GMT+08:00) Urumqi' => 'Asia/Urumqi',
'(GMT+09:00) Osaka' => 'Asia/Tokyo',
'(GMT+09:00) Sapporo' => 'Asia/Tokyo',
'(GMT+09:00) Seoul' => 'Asia/Seoul',
'(GMT+09:00) Tokyo' => 'Asia/Tokyo',
'(GMT+09:00) Yakutsk' => 'Asia/Yakutsk',
'(GMT+09:30) Adelaide' => 'Australia/Adelaide',
'(GMT+09:30) Darwin' => 'Australia/Darwin',
'(GMT+10:00) Brisbane' => 'Australia/Brisbane',
'(GMT+10:00) Canberra' => 'Australia/Sydney',
'(GMT+10:00) Guam' => 'Pacific/Guam',
'(GMT+10:00) Hobart' => 'Australia/Hobart',
'(GMT+10:00) Melbourne' => 'Australia/Melbourne',
'(GMT+10:00) Port Moresby' => 'Pacific/Port_Moresby',
'(GMT+10:00) Sydney' => 'Australia/Sydney',
'(GMT+10:00) Vladivostok' => 'Asia/Vladivostok',
'(GMT+11:00) Magadan' => 'Asia/Magadan',
'(GMT+11:00) New Caledonia' => 'Asia/Magadan',
'(GMT+11:00) Solomon Is.' => 'Asia/Magadan',
'(GMT+12:00) Auckland' => 'Pacific/Auckland',
'(GMT+12:00) Fiji' => 'Pacific/Fiji',
'(GMT+12:00) Kamchatka' => 'Asia/Kamchatka',
'(GMT+12:00) Marshall Is.' => 'Pacific/Fiji',
'(GMT+12:00) Wellington' => 'Pacific/Auckland',
'(GMT+13:00) Nuku\'alofa' => 'Pacific/Tongatapu'
);
function get_ipdb_list($IPDBS, $ipdb) {
$ret = '';
foreach ($IPDBS as $key=>$value) 
{
if ($value == $ipdb) {
$ret .= '<option value="' . $value . '" selected="selected">' . $value . '</option>';
} else {
$ret .= '<option value="' . $value . '">' . $value . '</option>';
}
}
return $ret;
}
$IPDB_LIST = get_ipdb_list($IPDBS, (defined('DEFAULT_IPDB') ? DEFAULT_IPDB : 'IP2LOCATION (English)'));
function get_tz_list($TIMEZONES, $tz) {
$ret = '';
foreach ($TIMEZONES as $key=>$value) 
{
if ($value == $tz) {
$ret = '<option value="' . $value . '" selected="selected">' . $key . '</option>' . $ret;
} else {
$ret = '<option value="' . $value . '">' . $key . '</option>' . $ret;
}
}
return $ret;
}
$TZ_LIST = get_tz_list($TIMEZONES, (defined('ADMIN_TIMEZONE') ? ADMIN_TIMEZONE : 'Asia/Shanghai'));
define('TB_ID_CACHE_TEXT', 'CREATE TABLE IF NOT EXISTS IDCache (
pKey INT NOT NULL PRIMARY KEY, 
UserDate VARCHAR(8) NOT NULL DEFAULT "", 
UserID INT NOT NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARACTER SET=utf8 COLLATE=utf8_unicode_ci');
define('TB_USER_TEXT', 'CREATE TABLE IF NOT EXISTS User (
Version SMALLINT NOT NULL DEFAULT 0, 
UserID BIGINT NOT NULL DEFAULT 0, 
Username VARCHAR(255) NOT NULL PRIMARY KEY, 
Password VARCHAR(32) NOT NULL DEFAULT "", 
Authority TINYINT NOT NULL DEFAULT 3,
SiteTB VARCHAR(16) NOT NULL DEFAULT "site",
TimeZone VARCHAR(32) NOT NULL DEFAULT "", 
ActivateCode INT NOT NULL DEFAULT 0, 
ActivateTime INT NOT NULL DEFAULT 0, 
CreateTime INT NOT NULL DEFAULT 0,
Activated TINYINT NOT NULL DEFAULT 0,
Message VARCHAR(255) NOT NULL DEFAULT "",
ExpiredDate INT NOT NULL DEFAULT 0,
MaxPV INT NOT NULL DEFAULT 0,
UNIQUE indexUID (UserID),
INDEX indexCT (CreateTime)
) ENGINE=InnoDB DEFAULT CHARACTER SET=utf8 COLLATE=utf8_unicode_ci');
define('TB_HOST_TEXT', 'CREATE TABLE IF NOT EXISTS host (
Hostname VARCHAR(255) NOT NULL PRIMARY KEY, 
Domain VARCHAR(255) NOT NULL DEFAULT "", 
Enabled TINYINT NOT NULL DEFAULT 1,
CreateTime INT NOT NULL DEFAULT 0,
UNIQUE indexDomain (Domain)
) ENGINE=InnoDB DEFAULT CHARACTER SET=utf8 COLLATE=utf8_unicode_ci');
define('TB_SITE_TEXT', 'CREATE TABLE IF NOT EXISTS site (
Version SMALLINT NOT NULL DEFAULT 0, 
UserID BIGINT NOT NULL DEFAULT 0,
SiteID BIGINT NOT NULL PRIMARY KEY, 
SiteName VARCHAR(255) NOT NULL DEFAULT "", 
TimeZone VARCHAR (32) NOT NULL DEFAULT "", 
DataCenter VARCHAR (128) NOT NULL DEFAULT "",
SiteDescription VARCHAR(255) NOT NULL DEFAULT "", 
SiteType TINYINT NOT NULL DEFAULT 0, 
SiteStatus TINYINT NOT NULL DEFAULT 0, 
VisitorPassword VARCHAR(16) NOT NULL DEFAULT "",
IPDatabase SMALLINT NOT NULL DEFAULT 0, 
CreateTime INT NOT NULL DEFAULT 0,
VisitType TINYINT NOT NULL DEFAULT 0,
INDEX indexUID (UserID),
INDEX indexCT (CreateTime),
INDEX indexDC (DataCenter)
) ENGINE=InnoDB DEFAULT CHARACTER SET=utf8 COLLATE=utf8_unicode_ci');
$CFG_OK = 0;
$ENV_OK = 0;
if (isset($_POST['opt'])) {
switch ((int)$_POST['opt']) {
case 1:
exit(Configure());
case 2:
exit(Authorize());
case 3:
exit(ApplyTrial());
}
}
if (isset($_GET['opt'])) {
switch ((int)$_GET['opt']) {
case 1:
exit(CheckEnv());
case 2:
exit(CheckCfg());
case 3:
if ($SKIP_CONFIG == 1) {
InstallCA();
exit('1Centcount Analytics is installing now.');
} else {
exit('0Server is not ready for installing Centcount Analytics yet. Please check again.');
}
}
}
if (isset($_GET['act'])) {
if ($_GET['act'] == 'env') $chk = 1;
if ($_GET['act'] == 'cfg') $chk = 2;
}
function ApplyTrial() {
$err = '';
$TrialURL = 'https://' . UPDATE_SERVER_MAIN . '/Try/2/update_trialkey.php?lan='.(empty($_POST['lan']) ? 0 : 1);
$ret = Download_File($TrialURL, '');
if (substr($ret, 0 ,1) === '1') {
$LICENSE = substr($ret, 1, 32);
$CID = substr($ret, 33); 
$file = __DIR__ . '/config/config_setting.php';
if (!file_exists($file)) return '0Settings file is not existed - Apply Trial Key.';
$txt = file_get_contents($file);
if (empty(ACCOUNT_ID) || empty(LICENSE_KEY) || strpos($txt, ACCOUNT_ID) === false || strpos($txt, LICENSE_KEY) === false) return '0Settings file is broken, Please resconfigure - Apply Trial Key.';
$txt = str_replace(array(ACCOUNT_ID, LICENSE_KEY), array($CID, $LICENSE), $txt);
$fh = fopen($file, 'w');
if (empty($fh)) return '0Write settings file failed - Apply Trial Key.';
fwrite($fh, $txt);
fclose($fh);
$err = '1Apply a trial key successfully!';
} else{
$err = "0Apply a trial key failed, Please try again!\r\n<br>" . $ret;
}
return $err;
}
function Authorize() {
$err = '';
if (empty($_POST['account_id'])) {
$err .= '<br>Account ID must not be empty';
}
if (empty($_POST['license_key'])) {
$err .= '<br>License key must not be empty';
}
if ($err === '') {
if ($_POST['license_key'] == LICENSE_KEY && $_POST['account_id'] == ACCOUNT_ID) {
return '1License key and account ID are already existed.';
}
switch(substr($_POST['license_key'], 0, 3)) {
case 'TRY':
$EDITION = 'Try';
break;
case 'BAS':
$EDITION = 'Basic';
break;
case 'PRO':
$EDITION = 'Pro';
break;
case 'TPS':
$EDITION = 'TPS';
break;
case 'CAE':
$EDITION = 'Caesar';
break;
default:
exit('0License key is not legal!');
}
$UPDATE_URL = 'https://' . UPDATE_SERVER_MAIN . '/'. $EDITION . '/' . CA_VERSION;
$ret = Download_File($UPDATE_URL.'/update_verify.php', 'key='.$_POST['license_key'].'&cid='.$_POST['account_id']);
if ($ret !== '1') exit('0License key is not legal! '. $ret);
$file = __DIR__ . '/config/config_setting.php';
if (!file_exists($file)) return '0Settings file is not existed';
$txt = file_get_contents($file);
if (empty(ACCOUNT_ID) || empty(LICENSE_KEY) || strpos($txt, ACCOUNT_ID) === false || strpos($txt, LICENSE_KEY) === false) return '0Settings file is broken. Please resconfigure.';
$txt = str_replace(array(ACCOUNT_ID, LICENSE_KEY), array($_POST['account_id'], $_POST['license_key']), $txt);
$fh = fopen($file, 'w');
if (empty($fh)) return '0Write settings file failed.';
fwrite($fh, $txt);
fclose($fh);
$err = '1Authorize Successfully';
} else {
if (substr($err,0,4) == '<br>') $err = '0'.substr($err,4);
}
return $err;
}
function Configure() {
$err = '';
$matchStr = filter_var($_POST['login_email'], FILTER_VALIDATE_EMAIL);
if (empty($_POST['login_email'])) {
$err .= '<br>Administrator login email must not be empty';
} else if ($_POST['login_email'] !== $matchStr) {
$err .= '<br>Administrator login email is not vaild';
}
if (empty($_POST['login_pw'])) {
$err .= '<br>Administrator login password must not be empty';
}
if (empty($_POST['admin_tz'])) {
$err .= '<br>Administrator timezone must not be empty';
}
if (empty($_POST['encode'])) {
$err .= '<br>Encode factor must not be empty';
}
if (empty($_POST['domain_name'])) {
$err .= '<br>Domain name must not be empty';
} 
if (empty($_POST['host_name'])) {
$err .= '<br>Server host name must not be empty';
} 
if (empty($_POST['host_model'])) {
$err .= '<br>Host model must not be empty';
}
if (empty($_POST['db_host'])) {
$err .= '<br>Database host must not be empty';
} 
if (empty($_POST['db_root'])) {
$err .= '<br>Database root username must not be empty';
}
if (empty($_POST['db_pw'])) {
$err .= '<br>Database password must not be empty';
} 
if (empty($_POST['mail_service'])) {
$err .= '<br>Mail service must not be empty';
}
if (empty($_POST['auto_update'])) {
$err .= '<br>Auto update database must not be empty';
} 
if (empty($_POST['protocol'])) {
$err .= '<br>cUrl protocol must not be empty';
} 
date_default_timezone_set($_POST['admin_tz']);
if ($err === '') {
$err = CreateConfigFile();
if ($err !== '1') return $err;
$err = ConfigCA($_POST['db_host'], $_POST['db_root'], $_POST['db_pw'], $_POST['login_email'], $_POST['login_pw'], $_POST['host_name'], $_POST['domain_name']);
} else {
if (substr($err, 0, 4) == '<br>') $err = '0'.substr($err, 4);
}
return $err;
}
function CreateConfigFile() {
$SettingFile = "
<?php
/*!
*******************************************************************************************************
* ATTENTION: THIS IS NOT FREE EDITION. FOR COMMERCIAL PURPOSES, PLEASE PURCHASE A COMMERCIAL LICENSE! *
*******************************************************************************************************
* File: Centcount Analytics SETTINGS CONFIG FILE                                                      *
* Version: 2.0                                                                                        *
* Author: WM Jonssen                                                                                  *
* Date: 02/28/2022                                                                                    *
* Copyright 2015-2022 WM Jonssen <wm.jonssen@gmail.com> - All rights reserved.                        *
* License: Dual licensed under the Free License and Commercial License.                               *
* Website: https://www.centcount.com                                                                  *
*******************************************************************************************************
*/
define('ENCODE_FACTOR', '{$_POST['encode']}');
define('HOST_NAME', '{$_POST['host_name']}');
define('HOST_MODEL', '{$_POST['host_model']}');
define('ACCOUNT_ID' , '{CID}');
define('LICENSE_KEY', '{KEY}');
define('DB_HOST', '{$_POST['db_host']}');
define('DB_USER', '{$_POST['db_root']}');
define('DB_PASSWORD', '{$_POST['db_pw']}');
define('DEFAULT_TIMEZONE', '');
define('DEFAULT_DC_DOMAIN', '');
define('DEFAULT_IPDB', '');
define('ADMIN_TIMEZONE', '{$_POST['admin_tz']}');
define('ADMIN_EMAIL', '{$_POST['login_email']}');
define('MAIL_SERVICE', {$_POST['mail_service']});
define('AUTO_UPDATE', {$_POST['auto_update']});
define('CURL_PROTOCOL', '{$_POST['protocol']}');
?>";
$RedisFile = "
<?php
/*!
*******************************************************************************************************
* ATTENTION: THIS IS NOT FREE EDITION. FOR COMMERCIAL PURPOSES, PLEASE PURCHASE A COMMERCIAL LICENSE! *
*******************************************************************************************************
* File: Centcount Analytics REDIS CONFIG FILE                                                         *
* Version: 2.0                                                                                        *
* Author: WM Jonssen                                                                                  *
* Date: 02/28/2022                                                                                    *
* Copyright 2015-2022 WM Jonssen <wm.jonssen@gmail.com> - All rights reserved.                        *
* License: Dual licensed under the Free License and Commercial License.                               *
* Website: https://www.centcount.com                                                                  *
*******************************************************************************************************
***************** IMPORTANT, DO NOT SHARE THESE REDIS DATABASES FOR OTHER PROGRAM !!! *****************
*******************************************************************************************************
*/
define('REDIS_IP_0', '127.0.0.1');
define('REDIS_PORT_0', 6379);
define('REDIS_DB_0', 0);
define('REDIS_IP_1', '127.0.0.1');
define('REDIS_PORT_1', 6379);
define('REDIS_DB_1', 1);
define('REDIS_IP_2', '127.0.0.1');
define('REDIS_PORT_2', 6379);
define('REDIS_DB_2', 2);
define('REDIS_IP_3', '127.0.0.1');
define('REDIS_PORT_3', 6379);
define('REDIS_DB_3', 3);
define('REDIS_IP_4', '127.0.0.1');
define('REDIS_PORT_4', 6379);
define('REDIS_DB_4', 4);
define('REDIS_IP_5', '127.0.0.1');
define('REDIS_PORT_5', 6379);
define('REDIS_DB_5', 5);
define('REDIS_IP_6', '127.0.0.1');
define('REDIS_PORT_6', 6379);
define('REDIS_DB_6', 6);
define('REDIS_IP_7', '127.0.0.1');
define('REDIS_PORT_7', 6379);
define('REDIS_DB_7', 7);
define('REDIS_IP_8', '127.0.0.1');
define('REDIS_PORT_8', 6379);
define('REDIS_DB_8', 8);
define('REDIS_IP_12', '127.0.0.1');
define('REDIS_PORT_12', 6379);
define('REDIS_DB_12', 12);
define('REDIS_AUTH', '{$_POST['redis_pw']}');
?>";
$dir = __DIR__ .'/config';
if (!file_exists($dir) && !mkdir($dir, 0755, true)) {
return '0Make directory "config" failed.';
}
$file = __DIR__ .'/config/config_setting.php';
$fh = fopen($file, 'w');
if (empty($fh)) return '0Create file "config_setting.php" failed.';
fwrite($fh, $SettingFile);
fclose($fh);
chmod($file, 0755);
$file = __DIR__ .'/config/config_redis.php';
$fh = fopen($file, 'w');
if (empty($fh)) return '0Create file "config_redis.php" failed.';
fwrite($fh, $RedisFile);
fclose($fh);
chmod($file, 0755);
return '1';
}
function ConfigCA($DB_HOST, $DB_User, $DB_PW, $user, $pw, $hostname, $domain) {
$err = '';
$con = mysqli_connect($DB_HOST, $DB_User, $DB_PW);
if (mysqli_connect_errno($con)) {
return '0Could not connect database, Database configs(host/user/password) are not correct. Please check it carefully.';
} 
$db_selected = mysqli_select_db($con, 'ccdata');
if (!$db_selected) {
if (!mysqli_query($con, 'CREATE DATABASE IF NOT EXISTS ccdata DEFAULT CHARACTER SET=utf8 COLLATE=utf8_unicode_ci')) {
return '0Creating CA database failed.';
}
}
$db_selected = mysqli_select_db($con, 'ccdata');
if (!$db_selected) {
return '0Use database failed.';
}
if (!check_table($con, 'User', 'ccdata')) {
if (!mysqli_query($con, TB_USER_TEXT)) {
return '0Create user table failed.';
}
}
if (!check_table($con, 'host', 'ccdata')) {
if (!mysqli_query($con, TB_HOST_TEXT)) {
return '0Create host table failed.';
}
$now = time();
$sql = "REPLACE INTO host VALUES('{$hostname}', '{$domain}', 1, $now)";
if (!mysqli_query($con, $sql)) {
return '0Add host failed.';
}
}
if (check_table($con, 'IDCache', 'ccdata')) {
$result = mysqli_query($con, 'SELECT * FROM IDCache WHERE pKey=1');
if (mysqli_num_rows($result)) {
while ($row = mysqli_fetch_assoc($result)) {
$UserDate = $row['UserDate'];
$UserID = $row['UserID'];
}
mysqli_free_result($result);
} else {
$UserDate = date('ymd');
$UserID = 0;
$sql = "REPLACE INTO IDCache VALUES(1, {$UserDate}, {$UserID})";
if (!mysqli_query($con, $sql)) {
return '0Fix Cache ID table failed.';
}
}
} else {
if (mysqli_query($con, TB_ID_CACHE_TEXT)) {
$UserDate = date('ymd');
$UserID = 0;
$sql = "REPLACE INTO IDCache VALUES(1, {$UserDate}, {$UserID})";
if (!mysqli_query($con, $sql)) {
return '0Initialize Cache ID table failed';
}
} else {
return '0Create Cache ID table failed.';
}
}
$CreateTime = time();
$Today = date('ymd');
if ($UserDate != $Today) {
$UserDate = $Today;
$UserID = 1;
$UID = (int)($UserDate . '0000001'); 
} else {
$UserID++;
$str = (string)$UserID;
$UID = (int)($UserDate . str_pad($str, 7, '0', STR_PAD_LEFT)); 
}
$sql = "UPDATE IDCache SET UserDate={$UserDate}, UserID={$UserID} WHERE pKey=1";
if (!mysqli_query($con, $sql) || mysqli_affected_rows($con) == 0) {
mysqli_close($con);
return '0Register failed when update user Cache ID.';
}
$md5pw = md5($pw);
$sql = "REPLACE INTO User(UserID, Username, Password, SiteTB, ActivateCode, ActivateTime, Activated, Authority, CreateTime) VALUES($UID, '{$user}', '{$md5pw}', 'site', 0, 0, 1, 9, {$CreateTime})";
if (mysqli_query($con, $sql)) {
if (!check_table($con, 'site', 'ccdata')) {
if (!mysqli_query($con, TB_SITE_TEXT)) {
mysqli_close($con);
return '0Create sites list table failed.';
}
}
} else {
return '0Register super administrator account failed, Please try again or send error information to us.';
}
mysqli_close($con);
return '1Congratulations! Configure Successfully.';
}
function CheckKeyFunc() {
$strsp = '<br><br><br>';
$error = '<p>';
$err_count = 0;
$hd = 0;
$error .= '<span>Check PHP KEY Function: </span>';
if (function_exists('popen') && ($hd = popen('free -m', 'r'))) {
pclose($hd);
return '';
} else {
$error .= '<br><i>popen -> Disabled (Must Be Enabled)</i>';
$err_count++;
}
$error .= $strsp;
$error .= '<b style="color:red;">PHP "popen" function is the necessary function in Centcount Analytics. Without it, Centcount Analytics will not work correctly. Please make sure "popen" function is enabled before installing Centcount Analytics.</b><br><br></p>';
return $error;
}
function CheckEnv() {
$error = CheckKeyFunc();
if ($error != '') return '0'. $error;
$strsp = '<br><br><br>';
$error = '<p>';
$err_count = 0;
$ENV_OK = 0;
$error .= '<span>Check Server Hardware: </span>';
$TMP_FP = popen('cat /proc/cpuinfo| grep "processor"| wc -l', 'r');
$tmp = trim(fread($TMP_FP, 1024));
pclose($TMP_FP);
if ($tmp) {
$error .= '<br>CPU: ' . $tmp . ((int)$tmp > 1 ? ' Cores' : ' Core');
}
$TMP_FP = popen('free -m | grep -E "^(Mem:)"', 'r');
$tmp = fread($TMP_FP, 1024);
pclose($TMP_FP);
if ($tmp) {
$tmp = preg_replace("/\s/", " ", $tmp);
$tmp = preg_replace("/\s(?=\s)/", "\\1", $tmp);
$tmp = explode(' ', $tmp);
if (count($tmp) > 3) {
$error .= '<br>Total Memory: ' . $tmp[1] . ' MB';
$error .= '<br>Free Memory: '  . $tmp[3] . ' MB';
$error .= '<br>Buffer/Cache: ' . ($tmp[1] - $tmp[2] - $tmp[3]) . ' MB';
}
}
$TMP_FP = popen('df -BM | grep -E "^(/)"', 'r');
$tmp = fread($TMP_FP, 1024);
pclose($TMP_FP);
if ($tmp) {
$tmp = preg_replace("/\s/", " ", $tmp);
$tmp = preg_replace("/\s(?=\s)/", "\\1", $tmp);
$tmp = explode(' ', $tmp);
$n = (int)(count($tmp) / 6);
$total = 0;
$used = 0;
for ($i=0; $i<$n; $i++) {
$t = $i * 6 + 1;
$total += (int)$tmp[$t];
$t = $i * 6 + 2;
$used += (int)$tmp[$t];
}
$total = (int)($total / 1024);
$used  = (int)($used / 1024);
$error .= '<br>Total Disk: ' . $total . ' GB';
$error .= '<br>Free Disk: '  . ($total - $used) . ' GB';
}
$error .= $strsp;
$error .= '<span>Check Version: </span>';
$TMP_FP = popen('cat /etc/issue', 'r');
$tmp = trim(fread($TMP_FP, 1024));
if (substr($tmp, 0, 6) == 'Ubuntu') {
$tmp = str_replace('\n \l', '', $tmp);
} else {
$TMP_FP = popen('cat /etc/redhat-release', 'r');
$tmp = trim(fread($TMP_FP, 1024));
$tmp = explode(' ', $tmp);
if ($tmp[0] == 'CentOS') {
$tmp = $tmp[0] . ' - ' . $tmp[3];
} else {
$tmp = '';
}
}
pclose($TMP_FP);
$OS_BIT = (log(PHP_INT_MAX + 1, 2) + 1);
if ($OS_BIT == 32) {
$error .= '<br><i>OS: ' . PHP_OS . ' - '. $tmp . ' - '. $OS_BIT . 'bit (Must Be 64bit OS)</i>';
$err_count++;
} else {
$error .= '<br>OS: ' . PHP_OS . ' - '. $tmp . ' - '. $OS_BIT . 'bit';
}
$error .= '<br>Server: ' . $_SERVER['SERVER_SOFTWARE'];
$PHP_CGI = '0';
$PHP_CLI = '1';
$tmp = explode('-', PHP_VERSION);
if ((float)$tmp[0] < 5.6) {
$error .= '<br><i>PHP CGI: ' . $tmp[0] . ' (Require >= 5.6)</i>';
$err_count++;
} else {
$error .= '<br>PHP CGI: ' . $tmp[0];
$PHP_CGI = $tmp[0];
}
$TMP_FP = popen('php -v', 'r');
$tmp = trim(fread($TMP_FP, 128));
pclose($TMP_FP);
if (substr($tmp, 0 ,3) != 'PHP') {
$error .= '<br><i>PHP CLI: Disabled (Must Be Enabled)</i>';
$err_count++;
} else {
$tmp1 = explode('-', $tmp);
$tmp2 = explode(' ', $tmp1[0]);
$error .= '<br>PHP CLI: '.$tmp2[1];
$PHP_CLI = $tmp2[1];
}
if ($PHP_CLI != $PHP_CGI) $error .= '<br><i>PHP CGI & PHP CLI are not same version!</i>';
$TMP_FP = popen('mysql -V', 'r');
$ret = trim(fread($TMP_FP, 128));
$tmp3 = $ret;
pclose($TMP_FP);
if (substr($ret, 0, 5) == 'mysql') {
if (strpos($ret, ", for ")) {
$tmp = explode(', for ', $ret);
} else {
$tmp = explode(' for ', $ret);
}
$ret = $tmp[0];
$tmp = trim(substr($ret, 10));
if (strpos($ret, "MariaDB")) {
$error .= '<br>MariaDB: ' . $tmp;
} else {
$error .= '<br>MySQL: ' . $tmp;
}
} else {
$error .= '<br><i>Local DB: Missed (Using Remote RDS, This check could be ignored. Error: '.$tmp3.')</i>';
}
$TMP_FP = popen('redis-server -v', 'r');
$tmp = trim(fread($TMP_FP, 256));
pclose($TMP_FP);
if (substr($tmp,0,5) == 'Redis') {
$tmp1 = explode(' ', $tmp);
if (substr($tmp1[2],0,2) == 'v=') {
$tmp2 = substr($tmp1[2],2);
if ((float)$tmp2 < 4) {
$error .= '<br><i>Redis: ' . $tmp2 . ' (Require >= 4.0)</i>';
$err_count++;
} else {
$error .= '<br>Redis: ' . $tmp2;
}
} else {
$error .= '<br><i>Redis: Missed</i>';
$err_count++;
}
} else {
$TMP_FP = popen('redis-cli -v', 'r');//redis-cli 3.0.6
$tmp = trim(fread($TMP_FP, 128));
$tmp3 = $tmp;
pclose($TMP_FP);
if (substr($tmp,0,9) == 'redis-cli') {
$tmp = substr($tmp,10);
if ((float)$tmp < 4) {
$error .= '<br><i>Redis: ' . $tmp . ' (Require >= 4.0)</i>';
$err_count++;
} else {
$error .= '<br>Redis: ' . $tmp;
}
} else {
$error .= '<br><i>Redis: Missed (Error: '.$tmp3.')</i>';
$err_count++;
}
}
$error .= $strsp;
$need = array('session'=>0,'cgi-fcgi'=>0,'curl'=>0,'mbstring'=>0,'gd'=>0,'json'=>0,'mysqli'=>0,'redis'=>0,'bcmath'=>0);
$Extensions = get_loaded_extensions();
if (count($Extensions)) {
$error .= '<span>Check PHP Extension: </span>';
foreach ($Extensions as $key => $value) {
if (array_key_exists($value, $need)) $need[$value] = 1;
}
foreach ($need as $key => $value) {
if ($value == 1) {
$error .= '<br>' . $key . ' -> OK';
} else {
$error .= '<br><i>' . $key . ' -> Missed</i>';
$err_count++;
}
}
} else {
$error .= '<i>Check PHP Extension Failed</i>';
$err_count++;
}
$error .= $strsp;
$need = array('popen'=>0);
$error .= '<span>Check PHP Function: </span>';
foreach ($need as $key => $value) {
$need[$key] = function_exists($key);
}
foreach ($need as $key => $value) {
if ($value == true) {
$error .= '<br>' . $key . ' -> Enabled';
} else {
$error .= '<br><i>' . $key . ' -> Disabled (Must Be Enabled)</i>';
$err_count++;
}
}
$error .= $strsp;
$error .= '<span>Check Installation Directory: </span>';
$error .= '<br>Root Directory: ' . $_SERVER['DOCUMENT_ROOT'];
$fmode = substr(sprintf('%o', fileperms($_SERVER['DOCUMENT_ROOT'])), -4);
if (substr($fmode, 1, 3) >= '777') {
$error .= '<br>Root Directory Mode: '.$fmode.' -> OK';
} else {
$error .= '<br><i>Root Directory Mode: '.$fmode.' -> Wrong (Must Be Changed To 0777)</i>';
$err_count++;
}
$error .= $strsp;
$error .= '<span>Check File Operation Permission: </span>';
$folder = 'testtmp';
file_exists($folder) && rmdir($folder);
if (mkdir($folder, 0755, true) && rmdir($folder)) {
$error .= '<br>Create Folder Permission -> OK';
} else {
$error .= '<br><i>Create Folder Permission -> NO Permission (Must Have Create Folder Permission)</i>';
$err_count++;
}
$file = 'test.tmp';
$fh = fopen($file, 'w');
if ($fh && fwrite($fh, ' ')) {
fclose($fh);
$error .= '<br>Create File Permission -> OK';
} else {
$error .= '<br><i>Create File Permission -> NO Permission (Must Have Create File Permission)</i>';
$err_count++;
}
if (chmod($file, 0755) && unlink($file)) {
$error .= '<br>Change File Mode Permission -> OK';
} else {
$error .= '<br>Change File Mode Permission -> NO Permission';
}
$error .= $strsp;
global $INSTALL_LANGUAGE, $LANGUAGE;
if ($err_count == 0) {
$ENV_OK = 1;
$error .= '<b>'. $INSTALL_LANGUAGE[$LANGUAGE]['EnvReady'] .'</b>';
} else if ($err_count == 1) {
if ($LANGUAGE == 'en-US') {
$error .= '<b style="color:red;">There is ' . $err_count . ' issue need to be solved before installing Centcount Analytics.</b>';
} else {
$error .= '<b style="color:red;">检查发现存在' . $err_count . '个问题需解决后才能继续下一步安装。</b>';
}
} else {
if ($LANGUAGE == 'en-US') {
$error .= '<b style="color:red;">There are ' . $err_count . ' issues need to be solved before installing Centcount Analytics.</b>';
} else {
$error .= '<b style="color:red;">检查发现存在' . $err_count . '个问题需解决后才能继续下一步安装。</b>';
}
}
$error .= '<br><br></p>';
return $ENV_OK.$error;
}
function CheckCfg() {
$strsp = '<br><br><br>';
$error  = '<p>';
$err_count = 0;
$CFG_OK = 0;
$error .= '<span>Check Config Files: </span>';
if (file_exists(__DIR__ . '/config/config_setting.php')) {
$error .= '<br>Setting Config File -> OK';
} else {
$error .= '<br><i>Setting Config File -> Missed</i>';
}
if (file_exists(__DIR__ . '/config/config_redis.php')) {
$error .= '<br>Redis Config File -> OK';
} else {
$error .= '<br><i>Redis Config File -> Missed</i>';
}
$error .= $strsp;
require_once __DIR__.'/config/config_setting.php';
require_once __DIR__.'/config/config_redis.php';
$con = mysqli_connect(DB_HOST, DB_USER, DB_PASSWORD);
$error .= '<span>Check Database Connection: </span>';
if (mysqli_connect_errno($con)) {
$error .= '<br><i>Connect Database -> Failed ('. mysqli_error($con) .')</i>';
$err_count++;
} else {
$error .= '<br>Connect Database -> OK';
}
$error .= $strsp;
if ($con) {
$need = array('ONLY_FULL_GROUP_BY'=>0,'STRICT_TRANS_TABLES'=>0,'ANSI_QUOTES'=>0);
$sql = "SELECT @@GLOBAL.sql_mode";
$result = mysqli_query($con, $sql);
if ($result && mysqli_num_rows($result)) {
$ret = mysqli_fetch_row($result);
$error .= '<span>Check SQL Mode: </span>';
$sql_mode = trim($ret[0]);
if ($sql_mode) {
$sql_mode = explode(',', trim($ret[0]));
foreach ($sql_mode as $key) {
if (array_key_exists($key, $need)) {
$error .= '<br><i>' . $key . ' -> Need To Be Removed</i>';
$err_count++;
} else {
$error .= '<br>' . $key . ' -> OK';
}
}
} else {
$error .= '<br>Not Set SQL Mode -> OK';
}
mysqli_free_result($result);
} else {
$error .= '<i>Check SQL Mode Failed</i>';
}
$error .= $strsp;
}
$error .= '<span>Check Redis Connection: </span>';
$REDIS_INSTALL = new Redis();
if ($REDIS_INSTALL->CONNECT(REDIS_IP_0, REDIS_PORT_0) !== true) {
$error .= '<br><i>Redis 0 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 0 -> OK';
}
$REDIS_1 = new Redis();
if ($REDIS_1->CONNECT(REDIS_IP_1, REDIS_PORT_1) !== true) {
$error .= '<br><i>Redis 1 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 1 -> OK';
}
$REDIS_2 = new Redis();
if ($REDIS_2->CONNECT(REDIS_IP_2, REDIS_PORT_2) !== true) {
$error .= '<br><i>Redis 2 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 2 -> OK';
}
$REDIS_3 = new Redis();
if ($REDIS_3->CONNECT(REDIS_IP_3, REDIS_PORT_3) !== true) {
$error .= '<br><i>Redis 3 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 3 -> OK';
}
$REDIS_4 = new Redis();
if ($REDIS_4->CONNECT(REDIS_IP_4, REDIS_PORT_4) !== true) {
$error .= '<br><i>Redis 4 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 4 -> OK';
}
$REDIS_5 = new Redis();
if ($REDIS_5->CONNECT(REDIS_IP_5, REDIS_PORT_5) !== true) {
$error .= '<br><i>Redis 5 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 5 -> OK';
}
$REDIS_6 = new Redis();
if ($REDIS_6->CONNECT(REDIS_IP_6, REDIS_PORT_6) !== true) {
$error .= '<br><i>Redis 6 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 6 -> OK';
}
$REDIS_7 = new Redis();
if ($REDIS_7->CONNECT(REDIS_IP_7, REDIS_PORT_7) !== true) {
$error .= '<br><i>Redis 7 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 7 -> OK';
}
$REDIS_8 = new Redis();
if ($REDIS_8->CONNECT(REDIS_IP_8, REDIS_PORT_8) !== true) {
$error .= '<br><i>Redis 8 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 8 -> OK';
}
$REDIS_12 = new Redis();
if ($REDIS_12->CONNECT(REDIS_IP_12, REDIS_PORT_12) !== true) {
$error .= '<br><i>Redis 12 -> ERROR</i>';
$err_count++;
} else {
$error .= '<br>Redis 12 -> OK';
}
$error .= $strsp;
global $INSTALL_LANGUAGE, $LANGUAGE;
if ($err_count == 0) {
$CFG_OK = 1;
$error .= '<b>'. $INSTALL_LANGUAGE[$LANGUAGE]['ConfigReady'] .'</b>';
} else if ($err_count == 1) {
if ($LANGUAGE == 'en-US') {
$error .= '<b style="color:red;">There is ' . $err_count . ' issue need to be solved before installing Centcount Analytics.</b>';
} else {
$error .= '<b style="color:red;">检查发现存在' . $err_count . '个问题需解决后才能继续下一步安装。</b>';
}
} else {
if ($LANGUAGE == 'en-US') {
$error .= '<b style="color:red;">There are ' . $err_count . ' issues need to be solved before installing Centcount Analytics.</b>';
} else {
$error .= '<b style="color:red;">检查发现存在' . $err_count . '个问题需解决后才能继续下一步安装。</b>';
}
}
$error .= '<br><br></p>';
return $CFG_OK.$error;
}
function check_table($con, $tb, $db) {
$ret = false;
$sql = "SHOW TABLES FROM {$db}";
$result = mysqli_query($con, $sql);
if ($result) {
while ($row = mysqli_fetch_row($result)) {
if ($row[0] == $tb) {
$ret = true;
break;
}
}
mysqli_free_result($result);
}
return $ret;
}
function InstallCA() {
ignore_user_abort(true);
set_time_limit(0);
define('MAX_DELAY', 15000000);
require_once __DIR__.'/config/config_setting.php';
require_once __DIR__.'/config/config_redis.php';
$REDIS_INSTALL = 0; 
$PROGRESS = ''; 
$UPD_VERSION = '';
global $REDIS_INSTALL, $PROGRESS, $UPD_VERSION;
date_default_timezone_set(ADMIN_TIMEZONE);
$REDIS_INSTALL = new Redis();
if ($REDIS_INSTALL->CONNECT(REDIS_IP_0, REDIS_PORT_0) !== true) exit;
if (REDIS_AUTH) $REDIS_INSTALL->AUTH(REDIS_AUTH);
$REDIS_INSTALL->SELECT(REDIS_DB_0);
$REDIS_INSTALL->SET('INSTALL_LOG', '');
$REDIS_INSTALL->SET('INSTALL_STATUS', '');
$REDIS_INSTALL->SET('INSTALL_PROGRESS', '');
$CHANGED_FILES = array();
$UPDATE_DIR = __DIR__;
$PROGRESS = '002';
Record_Msg('<br><span>Host Information:</span>');
Record_Msg('Host Name: ' . HOST_NAME . '<br>Host Model: ' . HOST_MODEL . '<br>Install Version: ' . INSTALL_VERSION . '<br>Install Time: ' . date('Y-m-d H:i:s') . '<br>Install Directory: ' . $UPDATE_DIR);
$PROGRESS = '004';
Record_Msg('<br><span>Check Download Server:</span>');
Record_Msg('Checking download server...');
$UPDATE_SERVER_LIST = explode(',', UPDATE_SERVER);
$UPDATE_SERVER = Select_Best_Server($UPDATE_SERVER_LIST);
if ($UPDATE_SERVER == '') Record_Msg('ERROR: Download server is not available now. Please try later.', 1);
switch(substr(LICENSE_KEY, 0, 3)) {
case 'TRY':
$EDITION = 'Try';
break;
case 'BAS':
$EDITION = 'Basic';
break;
case 'PRO':
$EDITION = 'Pro';
break;
case 'TPS':
$EDITION = 'TPS';
break;
case 'CAE':
$EDITION = 'Caesar';
break;
}
$UPDATE_URL = 'https://' . $UPDATE_SERVER . '/'. ($EDITION == 'Try' ? 'Basic' : $EDITION) . '/' . CA_VERSION;
$SOURCE_URL = 'https://' . $UPDATE_SERVER . '/source';
$PROGRESS = '006';
Record_Msg('<br><span>Check Latest Version Information:</span>');
Record_Msg('Checking latest version information...');
$ret = Download_File($UPDATE_URL . '/version_info.php');
if (empty($ret) || substr($ret, -3) != 'END') Record_Msg('Check Latest Version Information -> Failed.', 1);
$UPD_VERSION = substr($ret, 0, strlen($ret)-4);
Record_Msg('Latest Version: ' . $UPD_VERSION . ' - ' . ($EDITION == 'Try' ? 'Basic Trial' : $EDITION) . ' Edition<br>Ready for installing Centcount Analytics now!');
$PROGRESS = '008';
Record_Msg('<br><span>Verify License Key:</span>');
Record_Msg('Verifying license key...');
$ret = Download_File($UPDATE_URL . '/update_verify.php', 'key='.LICENSE_KEY.'&cid='.ACCOUNT_ID);
if ($ret === '1') {
Record_Msg('Verify license key successfully!');
} else{
Record_Msg('Verify license key failed!', 1);
}
$PROGRESS = '010';
Record_Msg('<br><span>Download Index File:</span>');
Record_Msg('Downloading index file...');
$ret = Download_File($UPDATE_URL . '/' .HOST_MODEL. '_index.php');
if (empty($ret) || substr($ret, -3) != 'END') Record_Msg('Fatal Error: Download index file failed.', 1);
$UPD = explode('$', $ret);
if (count($UPD) < 5 || $UPD[4] != 'END') Record_Msg('Fatal Error: Index file is not vaild.', 1);
$TOTAL_DOWNLOAD_FILES = substr_count($UPD[0], '=>') + substr_count($UPD[1], '=>');
Record_Msg('Total Download Files: ' . $TOTAL_DOWNLOAD_FILES . '<br>Download index file successfully!');
$PROGRESS = '010';
if ($UPD[0]) {
Record_Msg('<br><span>Check Installation File\'s MD5:</span>');
Record_Msg('Checking installation file\'s md5...');
$arr = explode(';', $UPD[0]);
$total = count($arr);
$UPDATE_FILE_LIST = array();
foreach($arr as $val) {
$tmp = explode('=>', $val);
if (empty($tmp[0]) || empty($tmp[1]) || strlen($tmp[1]) != 32) {
Record_Msg('Check Installation File MD5: '. $val .' -> Failed.', 1);
} else {
$UPDATE_FILE_LIST[$tmp[0]] = $tmp[1];
}
}
Record_Msg('Check installation file\'s md5 successfully!');
Record_Msg('<br><span>Download Installation Files:</span>');
Record_Msg('Downloading installation files...');
$n = 0;
$DOWNLOAD_URL = $UPDATE_URL . '/update_download.php';
$DOWNLOAD_ARG = 'key='.LICENSE_KEY.'&cid='.ACCOUNT_ID.'&mod='.HOST_MODEL.'&file=';
foreach($UPDATE_FILE_LIST as $file_name => $file_md5) {
$tmp = $UPDATE_DIR . $file_name;
if (file_exists($tmp) == false || md5_file($tmp) != $file_md5) {
if (file_exists($tmp.'.tmp.php') == false || md5_file($tmp.'.tmp.php') != $file_md5) {
$basename = basename($file_name);
$error = '';
$txt = Download_Update_File($DOWNLOAD_URL, $DOWNLOAD_ARG.$file_name, $file_md5, $error);
if ($txt === false) {
sleep(3);
$txt = Download_Update_File($DOWNLOAD_URL, $DOWNLOAD_ARG.$file_name, $file_md5, $error);
if ($txt === false) {
$error = $error ? '('. $error .').' : '.';
Record_Msg('Download Install File: '. $basename .' -> Failed'. $error, 1);
}
} 
if (Write_File($tmp.'.tmp.php', $txt) == false) {
Record_Msg('Download & Write Install File: '. $basename .' -> Failed.', 1);
}
Record_Msg('Download File: '. $basename .' -> OK.'); 
}
$CHANGED_FILES[] = $tmp;
$n++;
$PROGRESS = '0' . (floor(($n/$total) * 50) + 10);
}
}
Record_Msg('Download all install files successfully!');
}
$PROGRESS = '060';
if ($UPD[1]) {
Record_Msg('<br><span>Check Source File\'s MD5:</span>');
Record_Msg('Checking source file\'s md5...');
$arr = explode(';', $UPD[1]);
$total = count($arr);
$SOURCE_FILE_LIST = array();
foreach($arr as $val) {
$tmp = explode('=>', $val);
if (empty($tmp[0]) || empty($tmp[1]) || strlen($tmp[1]) != 32) {
Record_Msg('Check Source File MD5: '. $val .' -> Failed.', 1);
} else {
$SOURCE_FILE_LIST[$tmp[0]] = $tmp[1];
}
}
Record_Msg('Check source file\'s md5 successfully!');
Record_Msg('<br><span>Download Source Files:</span>');
Record_Msg('Downloading source files...');
$n = 0;
foreach($SOURCE_FILE_LIST as $file_name => $file_md5) {
$tmp = $UPDATE_DIR . $file_name;
if (file_exists($tmp) == false || md5_file($tmp) != $file_md5) {
if (file_exists($tmp.'.tmp.php') == false || md5_file($tmp.'.tmp.php') != $file_md5) {
$basename = basename($tmp);
$DOWNLOAD_URL = $SOURCE_URL . '/' . $basename;
if (Download_Source_File($DOWNLOAD_URL, $tmp, $file_md5) == false) {
sleep(3);
if (Download_Source_File($DOWNLOAD_URL, $tmp, $file_md5) == false) {
Record_Msg('Download Source File: '. $basename .' -> Failed.', 1);
}
}
Record_Msg('Download File: '. $basename .' -> OK.');
}
$CHANGED_FILES[] = $tmp;
$n++;
$PROGRESS = '0' . (floor(($n/$total) * 30) + 60);
}
}
Record_Msg('Download all source files successfully!');
}
$PROGRESS = '092';
Manage_Service('off');
$PROGRESS = '094';
if (count($CHANGED_FILES) > 0) {
Record_Msg('<br><span>Install Files:</span>');
Record_Msg('Installing all files...');
foreach ($CHANGED_FILES as $file) {
$basename = basename($file);
if (copy($file.'.tmp.php', $file)) {
chmod($file, 0755);
Record_Msg('Install File: ' . $basename . ' -> OK.');
} else {
Record_Msg('Install File: ' . $basename . ' -> Failed.', 2);
}
}
Record_Msg('Install all files successfully!');
}
$PROGRESS = '096';
Record_Msg('<br><span>Version Information File:</span>');
Record_Msg('Writing version information file...');
if (Rewrite_Version_File($UPD_VERSION) == false) Record_Msg('Write version information file failed.', 2);
Record_Msg('Write version information file successfully!');
$PROGRESS = '098';
Manage_Service('on');
$PROGRESS = '100';
Record_Msg('<br>Install Centcount Analytics successfully!', 3);
exit;
}
function Download_File($url, $arg='') {
$connect_timeout  = 15;
$download_timeout = 60;
$x = curl_init();
curl_setopt($x, CURLOPT_URL, $url);
curl_setopt($x, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($x, CURLOPT_HEADER, 0);
curl_setopt($x, CURLOPT_CONNECTTIMEOUT, $connect_timeout);
curl_setopt($x, CURLOPT_TIMEOUT, $download_timeout);
curl_setopt($x, CURLOPT_POSTFIELDS, $arg);
$ret = curl_exec($x);
$errno = curl_errno($x);
curl_close($x);
if ($errno > 0) return false;
return trim($ret);
}
function Download_Update_File($url, $arg, $filemd5, &$error) {
$basename = basename($arg);
Record_Msg('Downloading File: '. $basename .'...', -1);
$connect_timeout  = 15;
$download_timeout = 60;
$x = curl_init();
curl_setopt($x, CURLOPT_URL, $url);
curl_setopt($x, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($x, CURLOPT_HEADER, 0);
curl_setopt($x, CURLOPT_CONNECTTIMEOUT, $connect_timeout);
curl_setopt($x, CURLOPT_TIMEOUT, $download_timeout);
curl_setopt($x, CURLOPT_POSTFIELDS, $arg);
$ret = curl_exec($x);
$errno = curl_errno($x);
curl_close($x);
if ($errno > 0) return false;
$ret = rawurldecode(trim($ret));
$txt = substr($ret, 1);
if (empty($ret)) {$error = 'Empty File'; return false;}
if (substr($ret, 0, 1) == '0') {$error = $txt; return false;} 
if (md5($txt) != $filemd5) {$error = 'Broken File'; return false;}
return $txt;
}
function Download_Source_File ($url, $file, $filemd5) {
$basename = basename($file);
Record_Msg('Downloading File: '. $basename .'...', -1);
$download_timeout = 600;
$counter = 0;
$dir = dirname($file);
if (file_exists($dir) === false && CA_MKDIR($dir) === false) {
return false;
}
$file .= '.tmp.php';
$cmd = "wget -c -O{$file} {$url}";
$fh  = popen($cmd.' &', 'r');
if ($fh) {
pclose($fh);
while (true) {
$ret = '';
$chk = popen('ps aux|grep wget|grep '.$url, 'r');
if ($chk) $ret = trim(fread($chk, 2048));
if ($chk) pclose($chk);
if (strpos($ret, $cmd) === false) {
if (md5_file($file) != $filemd5) {
Record_Msg('Source file '. $basename .' is broken.');
return false;
}
chmod($file, 0755);
return true;
}
$counter++;
if ($counter > $download_timeout) {
Record_Msg('Download source file '. $basename .' timed out.');
return false;
}
sleep(1);
}
} 
return false;
}
function Write_File($file, $txt) {
$basename = basename($file);
$dir = dirname($file);
if (file_exists($dir) === false && CA_MKDIR($dir) === false) {
return false;
}
$fh = fopen($file, 'w');
if (empty($fh)) {
Record_Msg('Create File: '. $basename .' -> Failed (No Permission).');
return false;
}
if (fwrite($fh, $txt) === false) {
Record_Msg('Write File: '. $basename .' -> Failed.');
return false;
}
fclose($fh);
chmod($file, 0755);
return true;
}
function CA_MKDIR($dir) {
$tmp = str_replace(__DIR__, '', $dir);
$arr = explode('/', $tmp);
$folder = __DIR__;
foreach ($arr as $val) {
if ($val) {
$folder .= '/'. $val;
if (file_exists($folder) === false) {
if (mkdir($folder, 0755, true) === false) {
Record_Msg('Make Folder: '. $folder .' -> Failed.');
return false;
}
}
}
}
return true;
}
function Select_Best_Server($update_server_list) {
$best_speed  = MAX_DELAY;
$best_server = '';
$best_ping   = 0;
$best_delay  = 0;
$worst_delay = 0;
$tests = 4;
foreach ($update_server_list as $server) {
$sum_delay = 0;
$max_delay = 0;
$min_delay = MAX_DELAY;
$returns = 0;
for ($i=1; $i<=$tests; $i++) {
$delay = Speed_Test($server);
if ($delay < MAX_DELAY && $delay > 0) {
$sum_delay += $delay;
$returns++;
}
if ($delay > $max_delay && $delay != MAX_DELAY) $max_delay = $delay;
if ($delay < $min_delay && $delay != MAX_DELAY) $min_delay = $delay;
}
$avg_delay = $returns > 0 ? (int)($sum_delay / ($returns * 1000)) : MAX_DELAY;
if ($returns > 0) {
Record_Msg('Ping Download Server: '. $server .' -> Sent: '. $tests . ', Received: '. $returns .', Min Delay: '. (int)($min_delay / 1000) . 'ms, Max Delay: '. (int)($max_delay / 1000) . 'ms, Avg Delay: '. $avg_delay . 'ms.');
} else {
Record_Msg('Ping Download Server: '. $server .' -> No Response.');
}
if ($avg_delay < MAX_DELAY && $avg_delay < $best_speed && $returns > 2) {
$best_speed  = $avg_delay;
$best_server = $server;
$best_return = $returns;
$best_delay  = $min_delay;
$worst_delay = $max_delay;
}
}
if ($best_server) {
Record_Msg('Best Download Server: '. $best_server .' -> Sent: '. $tests . ', Received: '. $best_return .', Min Delay: '. (int)($best_delay / 1000) . 'ms, Max Delay: '. (int)($worst_delay / 1000) . 'ms, Avg Delay: '. $best_speed . 'ms.');
}
return $best_server;
}
function Speed_Test($server) {
$timeout = 15;
$url = 'https://' . $server . '/update_speedtest.dat';
$start_time = (int)(microtime(true) * 1E6);
$x = curl_init();
curl_setopt($x, CURLOPT_URL, $url);
curl_setopt($x, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($x, CURLOPT_HEADER, 0);
curl_setopt($x, CURLOPT_CONNECTTIMEOUT, $timeout);
curl_setopt($x, CURLOPT_TIMEOUT, $timeout);
$ret = curl_exec($x);
$errno = curl_errno($x);
curl_close($x);
$ret = trim($ret);
$delay_time = (int)(microtime(true) * 1E6) - $start_time;
if ($errno > 0 || strlen($ret) != 1024) $delay_time = MAX_DELAY;
return $delay_time;
}
function Manage_Service($status) {
global $REDIS_INSTALL;
$REDIS_INSTALL->SETEX('NormalStopService', 30, '1');
if ($status == 'off') {
Record_Msg('<br><span>Stop CA Service:</span>');
Record_Msg('Stopping CA service...');
$REDIS_INSTALL->SET('ProcessLimit', 1);
$PROCESS_ARRAY = $REDIS_INSTALL->SMEMBERS('ProcessList');
if (count($PROCESS_ARRAY) > 0) {
foreach ($PROCESS_ARRAY as $PID) $REDIS_INSTALL->HSET($PID, 'Status', 0);
}
sleep(3);
$PROCESS_ARRAY = $REDIS_INSTALL->KEYS('PID*');
if (count($PROCESS_ARRAY) > 0) {
foreach ($PROCESS_ARRAY as $PID) $REDIS_INSTALL->DEL($PID);
}
$REDIS_INSTALL->DEL('ProcessList');
$REDIS_INSTALL->SET('PersistenceStatus', 1);
$REDIS_INSTALL->SET('MailerStatus', 1);
$REDIS_INSTALL->SET('UpdaterStatus', 1);
sleep(5);
Record_Msg('Stop CA service successfully!');
} else if ($status == 'on') {
Record_Msg('<br><span>Start CA Service:</span>');
Record_Msg('Starting CA service...');
$REDIS_INSTALL->SET('ProcessLimit', 0);
$PROCESS_MAX = (int)$REDIS_INSTALL->GET('ProcessMax');
if ($PROCESS_MAX < 1) $PROCESS_MAX = 4;
for ($i = 0; $i < $PROCESS_MAX; $i++) {
if ($i == 0) unlink('ca.log');
pclose(popen('php -f ' . __DIR__  . '/kernel.php &', 'r'));
if ($i == 0) sleep(1);
}
$REDIS_INSTALL->SET('PersistenceStatus', 0);
$REDIS_INSTALL->DEL('PersistenceServiceMutualExclusion');
pclose(popen('php -f ' . __DIR__  . '/persistence.php &', 'r'));
$REDIS_INSTALL->SET('MailerStatus', 0);
$REDIS_INSTALL->DEL('MailServiceMutualExclusion');
pclose(popen('php -f ' . __DIR__  . '/mailer.php &', 'r'));
$REDIS_INSTALL->SET('UpdaterStatus', 0);
$REDIS_INSTALL->DEL('UpdateServiceMutualExclusion');
pclose(popen('php -f ' . __DIR__  . '/updater.php &', 'r'));
Record_Msg('Start CA service successfully!');
}
}
function Rewrite_Version_File($ver) {
$VersionHtml = "
<?php 
define('CA_VERSION', '{$ver}'); 
define('CA_UPDATE' , '". date('Y/m/d') ."'); 
?>";
$VersionFile = __DIR__ . '/ca_version.php';
$fh = fopen($VersionFile, 'w');
if (empty($fh)) return false;
fwrite($fh, $VersionHtml);
fclose($fh);
chmod($VersionFile, 0755);
return true;
}
function Record_Msg($msg, $status=0) {
global $REDIS_INSTALL, $PROGRESS;
$MSG =  $msg . '<br>';
$REDIS_INSTALL->SET('INSTALL_STATUS', filter_var($msg, FILTER_SANITIZE_STRING));
$REDIS_INSTALL->SET('INSTALL_PROGRESS', $PROGRESS);
if ($status >= 0) {
$REDIS_INSTALL->APPEND('INSTALL_LOG', $MSG);
} 
if ($status > 0) {
switch ($status) {
case 1:
case 2:
$MSG = '<br>GOT A FATAL ERROR WHEN INSTALLING CENTCOUNT ANALYTICS, THE INSTALLING PROCESS HAS BEEN TERMINATED!';
$REDIS_INSTALL->APPEND('INSTALL_LOG', $MSG);
$REDIS_INSTALL->SET('INSTALL_STATUS', filter_var($MSG, FILTER_SANITIZE_STRING));
$REDIS_INSTALL->SET('INSTALL_PROGRESS', '111');
break;
case 3:
global $UPD_VERSION;
$MSG = '<br>CONGRATULATIONS! CENTCOUNT ANALYTICS HAS BEEN SUCCESSFULLY INSTALLED. CURRENT VERSION: ' . $UPD_VERSION;
$REDIS_INSTALL->APPEND('INSTALL_LOG', $MSG);
$REDIS_INSTALL->SET('CurrentVersion', $UPD_VERSION);
$REDIS_INSTALL->SET('INSTALL_STATUS', filter_var($MSG, FILTER_SANITIZE_STRING));
break;
}
$REDIS_INSTALL->DEL('MutualExclusionInstalling');
exit;
}
}
?> 
<!DOCTYPE html>
<head>
<title><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['PageTitle'] ?></title>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta name="renderer" content="webkit|ie-comp|ie-stand"/>
<meta name="viewport" content="width=device-width, maximum-scale=1, user-scalable=yes"/>
<meta name="applicable-device" content="pc,mobile">
<meta name="author" content="WM Jonssen" />
<meta name="keywords" content="web analytics,heatmap,mouse tracking"/>
<meta name="description" content="Centcount Analytics is an open-source website analytics software. Developed by using PHP + MySQL + Redis, Can be easily deployed on your own server, 100% data ownership."/>
<style type="text/css">
html, body{font-size:12px; font-family:'Microsoft Yahei',Arial,Verdana; color:#555; padding:0px; margin:0px; border:0px; background-color:#f7f7f7;}
*{color:#555; font-family:"Microsoft Yahei",Arial,Verdana; font-weight:400; padding:0px; margin:auto; border:0; border-radius:0;}
h1{color:#222; letter-spacing:2px; margin-top:15px; margin-bottom:15px; height:36px;}
a{color:#0070c9; text-decoration:none; cursor:pointer;}
a:hover{text-decoration:underline;}
b{font-weight:bold; color:#bbb;}
i{color:red;}
img{display:block; vertical-align:middle;}
pre{font-family: "Source Code Pro","DejaVu Sans Mono","Ubuntu Mono","Anonymous Pro","Droid Sans Mono",Menlo,Monaco,Consolas,Inconsolata,Courier,monospace,"PingFang SC","Microsoft YaHei",sans-serif;}
p{width:calc(100vw - 30px); background-color:transparent; color:#888; font-size:14px; text-align:justify; line-height:22px; float:left;}
span{width:100%; height:auto; float:left; font-size:14px; text-align:justify; line-height:24px; margin-bottom:5px; border-bottom:#aaa 1px dashed; color:#aaa; font-weight:bold;}
.tal{text-align:left; word-break:break-all;}
.welcome{width:100%; min-width:300px; height:calc(100vh); display:none; background-color:#fff; position:fixed; top:0; left:0; text-align:center; z-index:999999;}
.pc{width:100%; height:60%; display:flex; align-items:center; justify-content:center;}
.wd, .ver, .bt, .wd2{width:100%; height:10%; font-size:34px; color:#000; text-align:center; font-weight:bold; display:flex; align-items:center; justify-content:center; opacity:0; animation:aniwrd 2s; -moz-animation:aniwrd 2s; -webkit-animation:aniwrd 2s; animation-delay:2s; -webkit-animation-delay:2s; animation-fill-mode:forwards;}
.ver{height:4%; font-size:14px; color:#333;}
.bt{font-size:30px; color:red; text-decoration:underline; animation-delay:3s; -webkit-animation-delay:3s;}
.wd2{height:20%;}
.dc{height:100%; animation:aniimg 2s; -moz-animation:aniimg 2s; -webkit-animation:aniimg 2s;}
.spaceTop, .spaceMid, .spaceBot{width:100%; height:4%;}
.spaceMid{height:2%;}
.spaceBot{height:3%;}
.InstallBox{width:100%; height:calc(100vh - 21px); position:fixed; z-index:999999; top:0px; left:0px; border:0px; border-bottom:#ccc 1px solid; margin:0px; padding:0px; background-position:top right; background-size:100% 100%; overflow:hidden; display:flex; align-items:center; justify-content:center; opacity:0; animation:aniwrd 2s; -moz-animation:aniwrd 2s; -webkit-animation:aniwrd 2s; animation-delay:0s; -webkit-animation-delay:0s; animation-fill-mode:forwards;}
.InstallWord{width: 100%; height: auto; margin: auto; float: left; padding-top: 30px; padding-bottom: 30px; display: flex; align-items: center; justify-content: center; background-color: rgba(0,0,0,0.85); color: #fff; opacity:0; animation:aniwrd 2s; -moz-animation:aniwrd 2s; -webkit-animation:aniwrd 2s; animation-delay:2s; -webkit-animation-delay:2s; animation-fill-mode:forwards;}
.WordBox{width:100%; max-width:960px; min-width:300px; height:auto; margin:auto; padding:10px; float:none; display:block; background-color:transparent; color:#fff;}
.InstallFooter{width:100%; min-width:300px; height:20px; line-height:20px; font-size:12px; font-family:Arial,"Microsoft Yahei",Verdana; background-color:#f7f7f7; color:#777; text-align:center; float:left; padding:0px; margin:0px; overflow:hidden; position:fixed; bottom:0px;}
.status, .progress{width:100%; height:20px; line-height:20px; font-size:12px; padding:0px; margin:0px; position:relative; left:0px; top:0px; background-color:transparent; z-index:99999999;}
.progress{width:0%; background-color:#1db91d; z-index:9999999; top:-20px;}
.show{width:100%; min-width:300px; height:calc(100vh - 21px); line-height:24px; margin:auto; font-size:14px; float:left; min-height:300px;}
.desc0, .desc1, .desc2{width:100%; height:auto; margin:0px; padding:0px; display:block; font-size:30px; font-weight:500;  line-height:40px; margin-bottom:15px; text-align:left; color:#eee;}
.desc1{font-size:20px; font-weight:400; line-height:30px; margin-bottom:15px;}
.desc2{font-size:14px; font-weight:300; line-height:22px;}
.TR{background-position:top left; background-size:100% 100%;}
.TL{background-position:top left; background-size:100% 100%;}
.TC{background-position:top left; background-size:100% 100%;}
.NoAni{animation-duration:0s; -webkit-animation-duration:0s; animation-delay:0s; -webkit-animation-delay:0s;}
@keyframes aniimg{from {height:10%;} to {height:100%;}}
@keyframes aniwrd{from {opacity:0;} to {opacity:1;}}
.agreement{width:100%; min-width:300px; height:calc(100vh); display:none; position:fixed; top:0; left:0; text-align:center; margin:auto; background:#111; z-index:99999;}
.agreebody{width:100%; min-width:300px; height:calc(100vh - 190px); overflow:hidden; border-top:#333 1px solid; border-bottom:#333 1px solid; padding:15px; float:none;}
.agreebox{width:calc(100% + 100px); min-width:400px; height:calc(100vh - 190px); overflow-y:auto;}
.agreebtn{width:auto; max-width:600px; min-width:300px; height:80px; line-height:80px; font-size:20px; font-weight:700; color:#fff; text-align:center; margin:auto; background-color:transparent; float:none;}
.setting{width:100%; min-width:300px; height:auto; background-color:#fff; text-align:center; display:none;}
.errmsg{width:calc(100% - 30px); height:auto; font-size:13px; line-height:18px; text-align:center; color:rgb(181,68,123); display:none; padding:15px; margin-bottom:15px; background-color:rgb(242,222,222); border-radius:4px; border:rgb(235,204,209) 1px solid; word-wrap:break-word; float:left;}
.header{width:100%; min-width:300px; font-size:14px; text-align:center; padding-top:10px; padding-bottom:10px; float:left; background-color:#f7f7f7;}
.body{border-top:#ccc 1px solid; border-bottom:#ccc 1px solid; display:flex; align-items:center; justify-content:center; text-align:center; padding-top:30px; padding-bottom:30px; width:100%; min-height:calc(100vh - 230px); float:left; font-size:14px; background-color:#fff;}
.box{width:calc(100% - 30px); max-width:600px; min-width:300px; height:auto; margin:auto; padding-left:15px; padding-right:15px; font-size:12px;}
.footer{width:100%; min-width:300px; height:80px; line-height:78px; font-size:12px; font-family:Arial,"Microsoft Yahei",Verdana; background-color:#f7f7f7; color:#777; text-align:center; float:left; padding:0px;}
.btnCHK{width:50%; text-align:center; float:left; display:none;}
.dShow{display:block;}
.dHide{display:none;}
.tabD, .tabF{width:100%; height:auto; margin:0px; padding:0px; float:left; display:none;}
.tabD{border:#ccc 1px solid; border-top:0px;}
.tabF{height:80px; line-height:80px; font-size:24px; background-color:#333; color:#fff; font-size:20px; font-weight:500; border:#333 1px solid;}
.price, .priceTop{height:50px; font-size:20px; font-weight:500; background-color:#eee; border-top:#ccc 1px solid;}
.priceTop{border:0px; border-bottom:#ccc 1px solid;}
.H35{height:40px;}
.spaceline{width:100%; height:1px; border-top:#ccc 1px dashed; margin:0px; padding-top:0px;}
.bTop{border-top:#ddd 1px dashed;}
td{width:100%; height:auto; line-height:16px; font-size:14px; text-align:left; margin-top:20px; float:left;}
tr, tbody, table, form{width:100%; border:0px; margin:0px; padding:0px; outline-style:none; outline-width:0px; border-spacing:0px; float:left;}
input{width:calc(100% - 12px); height:32px; line-height:32px; font-size:14px; border:#ccc 1px solid; ime-mode:disabled; outline-style:none; outline-width:0px; background-size:30px; float:left; padding-left:5px; padding-right:5px;} 
button, select{width:100%; height:34px; line-height:33px; color:#333; border:#ccc 1px solid; float:left; padding-left:5px; padding-right:5px; font-size:14px;}
textarea{width:100%; font-size:14px; color:#333; border:#ccc 1px solid; resize:none; float:left; padding-left:5px; padding-right:5px;}
button{opacity:0.9; background-color:#1092f8; color:#fff; border-color:#0c86e7;}
button:hover{opacity:1; border-color:#08538e;}
table, tbody, tr, th, td{width:100%; height:auto; float:none; background-color:#fff; font-weight:500;}
tr{border-top:0px; display:inline-table;}
th, td{width:100%; height:40px; background-color:#333; color:#fff; font-size:14px; line-height:20px; padding:15px; padding-top:10px; padding-bottom:10px; float:none;}
th{font-size:15px;}
td{height:20px; font-size:13px; text-align:center; background-color:#fff; color:#333;}
input, select{height:20px; line-height:20px; font-size:13px; padding:5px; font-weight:400; ime-mode:disabled;}
select{height:32px; line-height:32px;}
textarea{width:calc(100% - 12px); padding:5px; height:105px; line-height:17px; font-size:13px; float:none; outline-style:none;}
.Form1{text-align:left; height:22px; margin:0px; padding-top:6px; padding-bottom:0px; line-height:22px; font-size:13px; font-weight:500;}
.Form2{text-align:left; height:32px; margin:0px; padding-top:0px; padding-bottom:5px; line-height:32px; font-weight:400;}
.PB15{padding-bottom:15px;}
.PB30{padding-bottom:25px;}
.PT30{padding-top:20px;}
.btnB, .btnR, .btnG{opacity:0.9; display:block; margin:auto; text-align:center; width:240px; height:18px; line-height:18px; margin-top:10px; margin-bottom:10px; padding:10px; padding-top:11px; background-color:rgb(16,151,228); color:#fff; font-size:16px; border-radius:4px; float:none;}
.btnR{background-color:rgb(229,14,14);}
.btnG{background-color:#070707;}
.btnB:hover, .btnR:hover, .btnG:hover{opacity:1; text-decoration:none;}
@media only screen and (max-width: 480px) {
.agreebody{padding-left:10px; padding-right:10px;}
.TR{background-position:top right; background-size:auto 100%;}
.TL{background-position:top left; background-size:auto 100%;}
.TC{background-position:top center; background-size:auto 100%;}
p{width:calc(100vw - 20px);}
}
</style>
</head>
<body>
<div id="Welcome" class="welcome" <?php echo (isset($_GET['lan']) || $KEEP_INSTALL==1 ? '' : 'style="display:block;"') ?>>
<div class="spaceTop"></div>
<div id="WelcomeTitle" class="wd">
<?php echo $INSTALL_LANGUAGE[$LANGUAGE]['CA'] ?>
</div>
<div id="WelcomeVersion" class="ver">
<?php echo 'Ver: '.INSTALL_VERSION ?>
</div>
<div class="spaceMid"></div>
<div id="WelcomeImage" class="pc">
<svg width="100%" height="100%" class="dc" viewBox="0 0 110 110">
<path fill="transparent" d=" M 0.00 0.00 L 110.00 0.00 L 110.00 110.00 L 0.00 110.00 L 0.00 0.00 Z" />
<path fill="#191919" d=" M 38.19 9.15 C 45.90 4.35 54.77 0.76 64.00 1.17 C 78.30 1.06 92.05 9.60 98.76 22.16 C 92.98 23.71 87.34 26.21 83.13 30.59 C 81.52 30.09 79.60 28.66 78.46 30.69 C 77.73 32.31 79.17 33.76 80.24 34.80 C 84.12 35.17 88.20 34.09 91.95 35.37 L 92.28 36.07 C 89.98 39.88 86.97 43.22 84.75 47.09 C 84.94 51.32 88.80 54.85 88.77 59.23 C 87.77 59.83 86.72 60.33 85.63 60.74 C 85.65 65.19 84.88 69.72 86.69 73.95 C 83.05 78.82 75.74 77.64 70.81 75.53 C 70.92 79.64 75.39 79.99 78.11 81.87 C 82.20 84.38 85.86 87.53 89.56 90.57 C 92.62 93.13 93.70 97.13 94.25 100.91 C 83.00 106.84 69.67 110.68 57.03 107.36 C 32.48 103.23 12.78 80.01 13.22 55.03 C 12.72 36.74 22.74 18.81 38.19 9.15 Z" />
<path fill="#ffffff" d=" M 54.08 4.67 C 69.51 -0.04 87.17 7.34 95.59 20.90 C 90.89 22.27 86.50 24.61 82.89 27.93 C 77.87 23.81 71.61 20.85 64.99 21.16 C 54.15 20.91 43.92 28.67 40.67 38.92 C 39.00 43.75 39.18 49.02 40.42 53.93 C 36.72 54.74 33.13 56.02 29.76 57.76 C 24.92 47.89 24.45 35.91 29.00 25.86 C 33.47 15.40 42.96 7.23 54.08 4.67 Z" />
<path fill="#ffffff" d=" M 15.28 53.99 C 15.33 39.79 21.76 26.05 32.00 16.32 C 28.01 22.20 24.75 28.77 24.02 35.94 C 22.82 44.55 24.95 53.29 28.87 60.95 C 32.40 59.08 36.02 57.20 40.04 56.63 C 42.08 56.79 43.41 55.38 43.46 53.39 C 43.78 53.79 44.11 54.19 44.43 54.59 C 44.13 57.78 45.26 61.93 42.15 64.06 C 39.31 66.52 35.43 65.33 32.07 65.34 C 33.57 71.90 41.74 72.93 47.39 73.47 C 46.46 75.09 45.80 76.99 44.28 78.17 C 36.17 79.19 26.77 78.37 20.71 72.27 C 15.96 67.52 15.25 60.37 15.28 53.99 Z" />
<path fill="#ffffff" d=" M 51.02 27.94 C 58.94 21.80 70.54 21.85 78.77 27.39 C 77.83 28.54 76.91 29.71 76.00 30.89 C 71.21 28.14 65.44 26.70 59.99 28.23 C 53.09 29.82 47.27 35.31 45.25 42.09 C 44.15 45.26 44.34 48.66 44.29 51.96 C 43.70 51.82 42.52 51.54 41.93 51.40 C 40.19 42.65 43.84 33.22 51.02 27.94 Z" />
<path fill="#ffffff" d=" M 62.05 29.99 C 67.98 28.83 73.82 31.55 78.23 35.35 C 69.23 37.81 60.26 42.02 54.10 49.20 C 51.68 53.00 54.78 56.97 58.21 58.62 C 58.19 61.79 58.18 64.96 58.18 68.13 C 51.36 71.95 42.67 72.07 35.84 68.24 C 39.94 67.86 44.53 66.35 46.18 62.17 C 46.90 56.45 45.92 50.64 46.74 44.92 C 47.98 37.34 54.43 31.02 62.05 29.99 Z" />
<path fill="#ffffff" d=" M 60.31 46.08 C 68.54 39.95 78.68 36.39 89.00 36.82 C 87.07 40.14 84.78 43.22 82.49 46.30 C 79.26 46.40 75.93 45.85 72.79 46.79 C 69.92 48.13 67.74 51.89 69.33 54.93 C 70.46 57.99 74.31 58.45 75.83 61.19 C 77.54 63.75 76.82 67.04 77.87 69.78 C 79.54 72.11 82.62 72.18 85.11 72.97 C 80.41 76.97 72.88 75.37 68.96 70.99 C 65.41 66.99 63.95 61.29 64.79 56.04 C 64.97 53.87 65.81 51.46 64.50 49.46 C 63.63 47.79 61.82 47.03 60.31 46.08 Z" />
<path fill="#ffffff" d=" M 71.51 54.67 C 70.28 52.40 71.64 49.21 74.19 48.65 C 76.92 48.25 79.68 48.45 82.43 48.44 C 83.86 51.53 85.19 54.67 86.61 57.77 C 83.71 57.91 82.66 60.27 83.54 62.81 C 82.37 63.03 79.62 63.11 80.86 64.99 C 81.51 65.12 82.81 65.39 83.46 65.53 C 83.29 67.17 83.14 68.81 83.00 70.45 C 81.95 69.77 80.27 69.71 79.65 68.52 C 79.02 65.74 79.25 62.70 77.74 60.17 C 76.43 57.58 73.31 56.80 71.51 54.67 Z" />
<path fill="#ffffff" d=" M 55.45 53.01 C 54.70 49.73 59.21 46.91 61.68 49.38 C 63.79 50.96 62.63 53.91 62.56 56.09 C 61.72 61.94 63.58 68.10 67.54 72.51 C 69.00 73.94 69.03 76.07 69.50 77.93 C 62.24 76.15 54.81 76.86 47.51 77.88 C 48.29 76.28 49.05 74.66 49.81 73.04 C 53.62 72.68 57.18 71.22 60.43 69.25 C 60.30 65.04 60.31 60.84 60.41 56.63 C 58.51 55.83 56.00 55.38 55.45 53.01 Z" />
<path fill="#191919" d=" M 74.14 51.82 C 76.20 50.49 78.64 50.18 81.05 50.43 C 80.42 52.18 80.43 53.95 81.08 55.72 C 78.38 55.22 76.27 53.40 74.14 51.82 Z" />
<path fill="#ffffff" d=" M 18.94 73.83 C 26.49 80.78 37.38 81.52 47.08 80.16 C 56.05 78.77 65.58 78.09 74.10 81.87 C 59.35 79.59 45.63 88.20 30.92 86.74 C 29.08 86.54 27.10 86.35 25.53 85.28 C 22.69 81.88 20.78 77.82 18.94 73.83 Z" />
<path fill="#ffffff" d=" M 27.91 88.58 C 44.64 91.83 60.58 79.99 77.24 85.05 C 72.93 85.19 68.54 85.17 64.44 86.68 C 55.27 89.85 46.87 95.80 36.91 96.26 C 33.42 94.36 30.76 91.30 27.91 88.58 Z" />
<path fill="#ffffff" d=" M 39.30 98.08 C 49.73 97.15 58.21 90.20 68.23 87.86 C 71.45 87.02 74.79 87.29 78.08 87.29 C 67.51 88.35 60.87 97.60 51.69 101.75 C 47.33 104.21 43.08 99.91 39.30 98.08 Z" />
<path fill="#ffffff" d=" M 70.11 92.08 C 75.24 89.06 82.40 87.70 87.44 91.60 C 90.28 93.34 91.40 96.63 91.93 99.75 C 84.71 103.67 76.61 105.92 68.38 106.06 C 68.14 103.67 68.76 100.95 66.98 99.01 C 65.76 101.13 65.38 103.54 65.09 105.93 C 60.69 105.95 56.35 105.14 52.09 104.13 C 58.58 100.84 63.96 95.87 70.11 92.08 Z" />
</svg>
</div>
<div class="spaceBot"></div>
<div id="WelcomeStart" class="wd" style="max-width:360px;">
<a class="bt" style="text-align:right;" href="?lan=en-US">ENGLISH</a>
<a class="bt" style="text-align:left;"  href="?lan=zh-CN">简体中文</a>
</div>
</div>
<div id="Agreement" class="agreement" <?php echo (isset($_GET['lan']) && $KEEP_INSTALL==0 ? 'style="display:block;"' : '') ?>>
<div class="agreebtn">
<?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Agreement'] ?>
</div>
<div class="agreebody">
<div class="agreebox">
<?php echo $AGREEMENT[$LANGUAGE] ?>
</div>
</div>
<div class="agreebtn">
<a onclick="hide_me('Agreement'); show_me('CheckEnv'); CA_GET(1)"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Accept'] ?></a>
</div>
</div> 
<div id="CheckEnv" class="agreement">
<div class="agreebtn">
<?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Environment'] ?>
</div>
<div class="agreebody">
<div id="EnvBox" class="agreebox"></div>
</div>
<div class="agreebtn">
<a class="btnCHK dShow" onclick="CA_GET(1);"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['CheckAgain'] ?></a>
<a class="btnCHK" id="EnvNext" onclick="hide_me('CheckEnv'); show_set('config')"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['NextStep'] ?></a>
</div>
</div> 
<div id="CheckCfg" class="agreement">
<div class="agreebtn">
<?php echo $INSTALL_LANGUAGE[$LANGUAGE]['CheckConfig'] ?>
</div>
<div class="agreebody">
<div id="CfgBox" class="agreebox"></div>
</div>
<div class="agreebtn">
<a class="btnCHK dShow" onclick="CA_GET(2);"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['CheckAgain'] ?></a>
<a class="btnCHK" id="CfgNext" onclick="hide_me('CheckCfg'); show_set('install')"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['NextStep'] ?></a>
<a class="btnCHK" id="CfgPrev" onclick="hide_me('CheckCfg'); show_set('config')" style="color:red;"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['PreStep'] ?></a>
</div>
</div> 
<div id="Setting" class="setting">
<div class="header">
<img src="https://<?php echo $SUBDOMAIN ?>.centcount.com/images/logo.svg" style="height:68px;" alt='Centcount Analytics Logo' />
</div>
<div class="body">
<div class="box">
<div class="errmsg" id="errormsg"></div>
<div id="ConfigTitle" class="tabF"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Configuration'] ?></div>
<div id="ConfigForm" class="tabD">
<table>
<?php echo ($SKIP_CONFIG == 0 ? '' : '
<tr><td class="H35 priceTop">
<a class="btnB" onclick="hide_me(\'Setting\'); show_me(\'CheckCfg\'); CA_GET(2);">'. $INSTALL_LANGUAGE[$LANGUAGE]['AlreadyConfigured']. '</a>
</td></tr>')
?>
<tr><td class="Form1 PT30"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['AdminLoginEmail'] ?></td></tr>
<tr><td class="Form2"><input type="email" name="login_email" id="Login Email" maxlength="255" autocomplete="new-password" value="<?php echo (defined('ADMIN_EMAIL') ? ADMIN_EMAIL : '') ?>" placeholder="Enter administrator login email..." onblur="checkEmail(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['AdminLoginPW'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="login_password" id="Login Password" maxlength="32" autocomplete="new-password" placeholder="Enter administrator login password..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['AdminTimezone'] ?></td></tr>
<tr><td class="Form2 PB30">
<select class="" name="admin_tz" id="Admin Timezone">
<?php echo $TZ_LIST ?>
</select>
</td></tr>
<tr><td class="spaceline"></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['DatabaseHost'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="db_host" id="Database Host" maxlength="39" value="<?php echo (defined('DB_HOST') ? DB_HOST : '127.0.0.1') ?>" placeholder="Enter database host (default: 127.0.0.1)..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['DatabaseRoot'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="root_user" id="Database Root Username" maxlength="32" value="root" placeholder="Enter database root username..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['DatabaseRootPW'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="root_pw" id="Database Root Password" maxlength="32" value="<?php echo (defined('DB_PASSWORD') ? DB_PASSWORD : '') ?>" autocomplete="new-password" placeholder="Enter database root password..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['RedisAuth'] ?></td></tr>
<tr><td class="Form2 PB30"><input type="text" name="redis_pw" id="Redis Password" maxlength="32" value="<?php echo (defined('REDIS_AUTH') ? REDIS_AUTH : '') ?>" autocomplete="new-password" placeholder="Enter redis password..." onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="spaceline"></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['EncodeFactor'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="encode_factor" id="Encode Factor" maxlength="32" value="<?php echo md5(mt_rand(1E7, mt_getrandmax())) ?>" disabled="" placeholder="Enter the encode factor (IT IS VERY IMPORTANT)..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['DomainName'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="domain_name" id="Domain Name" maxlength="256" value="<?php echo ($_SERVER['SERVER_PORT'] == 80 || $_SERVER['SERVER_PORT'] == 443 ? $_SERVER['SERVER_NAME'] : $_SERVER['SERVER_NAME'].':'.$_SERVER['SERVER_PORT']) ?>" placeholder="Enter the domain name (e.g: example.com:8080)..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['HostName'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="host_name" id="Host Name" maxlength="32" value="<?php echo (defined('HOST_NAME') ? HOST_NAME : 'Centcount-Analytics-Host') ?>" placeholder="Enter the server host name (e.g: Centcount-Analytics-Host)..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['HostModel'] ?></td></tr>
<tr><td class="Form2 PB30">
<select class="" name="host_model" id="Host Model">
<option value="MASTER" selected="">MASTER</option>
<option value="SLAVE" disabled="">SLAVE (Only for TPS edition)</option>
</select>
</td></tr>
<tr><td class="spaceline"></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['MailService'] ?></td></tr>
<tr><td class="Form2">
<select class="" name="mail_service" id="Mail Service">
<option value="0">No Mail Service</option>
<option value="1" selected="">CA Free Mail Service</option>
<option value="2">Self Hosted Mail Service</option>
</select>
</td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['AutoUpdate'] ?></td></tr>
<tr><td class="Form2">
<select class="" name="auto_update" id="Auto Update">
<option value="0">Off</option>
<option value="1" selected="">On</option>
</select>
</td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['cURLProtocol'] ?></td></tr>
<tr><td class="Form2 PB30">
<select class="" name="protocol" id="cURL Protocol">
<option value="https://" selected="">HTTPS</option>
<option value="http://">HTTP</option>
</select>
</td></tr>
<tr><td class="H35 price">
<a class="btnR" onclick="CA_POST(1)"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Configure'] ?></a>
<?php echo ($SKIP_CONFIG == 0 ? '' : '
<div class="bTop"></div>
<a class="btnB" onclick="hide_me(\'Setting\'); show_me(\'CheckCfg\'); CA_GET(2);">'. $INSTALL_LANGUAGE[$LANGUAGE]['AlreadyConfigured'] .'</a>')
?>
</td></tr>
</table>
</div>
<div id="InstallTitle" class="tabF"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Authorization'] ?></div>
<div id="InstallForm" class="tabD">
<table>
<?php echo (defined('LICENSE_KEY') && LICENSE_KEY != '{KEY}' ? 
'<tr><td class="H35 priceTop">
<a class="btnB" onclick="hide_me(\'Setting\');show_me(\'Installing\');">'. $INSTALL_LANGUAGE[$LANGUAGE]['AlreadyAuthorized'] .'</a>
</td></tr>' : 
'<tr><td class="H35 priceTop">
<a class="btnR" href="'. $PURCHASE_URL .'" target="_blank">'. $INSTALL_LANGUAGE[$LANGUAGE]['Purchase'] .'</a>
</td></tr>')
?>
<tr><td class="Form1 PT30"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['AccountID'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="cid" id="Account ID" maxlength="16" value="<?php echo (defined('ACCOUNT_ID') && ACCOUNT_ID != '{CID}' ? ACCOUNT_ID : '') ?>" placeholder="Enter your account ID..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="Form1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['LicenseKey'] ?></td></tr>
<tr><td class="Form2"><input type="text" name="license_key" id="License Key" maxlength="32" value="<?php echo (defined('LICENSE_KEY') && LICENSE_KEY != '{KEY}' ? LICENSE_KEY : '') ?>" placeholder="Enter your license key..." onblur="checkValue(this.id)" onfocus="setStyle(this.id)"/></td></tr>
<tr><td class="PB30" style="text-align:left;">
<?php echo $INSTALL_LANGUAGE[$LANGUAGE]['AuthorityTip'] ?>
</td></tr>
<tr><td class="H35 price">
<a class="btnR" onclick="CA_POST(2)"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Authorize'] ?></a>
<div class="bTop"></div>
<a class="btnB" click="CA_POST(3)" href="https://www.centcount.com/signup.php"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['ApplyTrialKey'] ?></a>
</td></tr>
</table>
</div>
</div>
</div>
<div class="footer">
Copyright &copy; 2015 - <?php echo date('Y') ?> <a href="about.php">WM Jonssen</a>. All rights reserved.
</div>
</div>
<div id="Installing" class="setting">
<div id="Step0" class="InstallBox">
<div id="Show" class="show">
<div id="InstallTitle" class="wd2 NoAni">
<?php echo $INSTALL_LANGUAGE[$LANGUAGE]['CA'] ?>
</div>
<div id="InstallImage" class="pc NoAni">
<img class="dc NoAni" src="https://<?php echo $SUBDOMAIN ?>.centcount.com/images/logo.svg" />
</div>
<div id="InstallStart" class="wd2 NoAni">
<a id="InstallNow" class="bt NoAni" onclick="Reinstall()"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Install'] ?></a>
</div>
</div>
</div>
<div id="Step1" class="InstallBox TC dHide" style="background-image:url(https://<?php echo $SUBDOMAIN ?>.centcount.com/images/install/install_privacy.jpg);">
<div class="InstallWord">
<div class="WordBox">
<h1 class="desc0"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Privacy0'] ?></h1>
<h2 class="desc1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Privacy1'] ?></h2>
<p  class="desc2"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Privacy2'] ?></p>
</div>
</div>
</div>
<div id="Step2" class="InstallBox TL dHide" style="background-image:url(https://<?php echo $SUBDOMAIN ?>.centcount.com/images/install/install_introduction.jpg);">
<div class="InstallWord">
<div class="WordBox">
<h1 class="desc0"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Introduction0'] ?></h1>
<h2 class="desc1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Introduction1'] ?></h2>
<p  class="desc2"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Introduction2'] ?></p>
</div>
</div>
</div>
<div id="Step3" class="InstallBox TR dHide" style="background-image:url(https://<?php echo $SUBDOMAIN ?>.centcount.com/images/install/install_heatmap.jpg);">
<div class="InstallWord">
<div class="WordBox">
<h1 class="desc0"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Heatmap0'] ?></h1>
<h2 class="desc1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Heatmap1'] ?></h2>
<p  class="desc2"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Heatmap2'] ?></p>
</div>
</div>
</div>
<div id="Step4" class="InstallBox TC dHide" style="background-image:url(https://<?php echo $SUBDOMAIN ?>.centcount.com/images/install/install_godview.jpg);">
<div class="InstallWord">
<div class="WordBox">
<h1 class="desc0"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['GodView0'] ?></h1>
<h2 class="desc1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['GodView1'] ?></h2>
<p  class="desc2"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['GodView2'] ?></p>
</div>
</div>
</div>
<div id="Step5" class="InstallBox TL dHide" style="background-image:url(https://<?php echo $SUBDOMAIN ?>.centcount.com/images/install/install_report.jpg);">
<div class="InstallWord">
<div class="WordBox">
<h1 class="desc0"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Report0'] ?></h1>
<h2 class="desc1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Report1'] ?></h2>
<p  class="desc2"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Report2'] ?></p>
</div>
</div>
</div>
<div id="Step6" class="InstallBox TC dHide" style="background-image:url(https://<?php echo $SUBDOMAIN ?>.centcount.com/images/install/install_security.jpg);">
<div class="InstallWord">
<div class="WordBox">
<h1 class="desc0"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Security0'] ?></h1>
<h2 class="desc1"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Security1'] ?></h2>
<p  class="desc2"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Security2'] ?></p>
</div>
</div>
</div>
<div class="InstallFooter">
<div id="Status" class="status"></div>
<div id="Progress" class="progress"></div>
</div>
</div>
<div id="Installation" class="agreement">
<div class="agreebtn">
<?php echo $INSTALL_LANGUAGE[$LANGUAGE]['InstallLog'] ?>
</div>
<div class="agreebody">
<div id="LogBox" class="agreebox"></div>
</div>
<div class="agreebtn">
<a id="SingIn" href="signin.php"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['SignIn'] ?></a>
<a id="Reconfigure" class="btnCHK dShow" onclick="hide_me('Installation'); show_set('config')"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Reconfigure'] ?></a>
<a id="Reinstall" class="btnCHK" onclick="hide_me('Installation'); Reinstall()" style="color:red;"><?php echo $INSTALL_LANGUAGE[$LANGUAGE]['Reinstall'] ?></a>
</div>
</div> 
<script type="text/javascript">
var LANGUAGE = '<?php echo $LANGUAGE ?>';
var IMGURL = '<?php echo $IMAGE_URL ?>';
function hide_me(id) {
document.getElementById(id).style.display = "none";
}
function show_me(id) {
document.getElementById(id).style.display = "block";
}
function flex_me(id) {
document.getElementById(id).style.display = "flex";
}
function setStyle(x){
document.getElementById(x).style.borderColor="#39F";
}
function get_txt(id) {
return document.getElementById(id).innerHTML;
}
function get_val(id) {
return document.getElementById(id).value;
}
function set_txt(id, txt) {
document.getElementById(id).innerHTML = txt;
}
function set_val(id, txt) {
document.getElementById(id).value = txt;
}
function checkValue(x){
if(document.getElementById(x).value == ""){
document.getElementById("errormsg").innerHTML = x + " must not be empty";
document.getElementById("errormsg").style.display = "block";
document.getElementById(x).style.borderColor = "#f00";
return false;
} else {
document.getElementById("errormsg").innerHTML = "";
document.getElementById("errormsg").style.display = "none";
document.getElementById(x).style.borderColor = "#ccc";
}
}
function checkUser(x){
var username= document.getElementById(x).value;
if (username == ""){
document.getElementById("errormsg").innerHTML = x + " must not be empty";
document.getElementById("errormsg").style.display = "block";
document.getElementById(x).style.borderColor = "#f00";
} else {
document.getElementById("errormsg").innerHTML = "";
document.getElementById("errormsg").style.display = "none";
document.getElementById(x).style.borderColor = "#ccc";
}
} 
function checkPW(x){
var pw= document.getElementById(x).value;
if (pw.length < 6){
document.getElementById("errormsg").innerHTML = x + " must be at least 8 characters long";
document.getElementById("errormsg").style.display = "block";
document.getElementById(x).style.borderColor = "#f00";
} else {
document.getElementById("errormsg").innerHTML = "";
document.getElementById("errormsg").style.display = "none";
document.getElementById(x).style.borderColor = "#ccc";
}
}
function matchPW(x,y) {
var pw = document.getElementById(x).value;
var cpw = document.getElementById(y).value;
if (pw != cpw) {
document.getElementById("errormsg").innerHTML = "Passwords do not match";
document.getElementById("errormsg").style.display = "block";
document.getElementById(y).style.borderColor = "#f00";
} else {
document.getElementById("errormsg").innerHTML = "";
document.getElementById("errormsg").style.display = "none";
document.getElementById(y).style.borderColor = "#ccc";
} 
}
function checkEmail(x) {
if (checkValue(x) == false) return;
var email = document.getElementById(x).value;
var reg  = /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
if (reg.test(email) == false) {
document.getElementById("errormsg").innerHTML = "Email is not valid";
document.getElementById("errormsg").style.display = "block";
document.getElementById(x).style.borderColor = "#f00";
} else {
document.getElementById("errormsg").innerHTML = "";
document.getElementById("errormsg").style.display = "none";
document.getElementById(x).style.borderColor = "#ccc";
}
} 
function checkNull(x) {
var ret = 1;
for (let k in x) {
if (document.getElementById(x[k]).value == "") {
document.getElementById(x[k]).style.borderColor = "#f00";
ret = 0;
}
}
return ret;
}
function show_set(opt) {
if (opt == 'config') {
hide_me("InstallTitle");
hide_me("InstallForm");
show_me("ConfigTitle");
show_me("ConfigForm");
show_me("Setting");
} else if (opt == 'install') {
hide_me("ConfigTitle");
hide_me("ConfigForm");
show_me("InstallTitle");
show_me("InstallForm");
show_me("Setting");
}
}
var INSTALL_SUCCESS = 0;
function CA_GET(opt) {
try {
var c, 
a = '',
b = '',
url = 'install.php?lan=' + LANGUAGE + '&opt=' + opt + '&rnd=' + Math.random();
switch (opt) {
case 1:
set_txt('EnvBox', '');
break;
case 2:
set_txt('CfgBox', '');
break;
}
if (window.XMLHttpRequest) {
c = new XMLHttpRequest();
} else {
c = new ActiveXObject('Microsoft.XMLHTTP');
}
c.open('GET', url, true);
c.send(); 
c.onreadystatechange = function() {
if (c.readyState == 4 && c.status == 200) {
a = c.responseText.replace(/(^\s*)|(\s*$)/g, '');
b = a.substr(0, 1);
if (b == '0') {
switch (opt) {
case 1:
set_txt('EnvBox', a.substr(1));
hide_me('EnvNext');
break;
case 2:
set_txt('CfgBox', a.substr(1));
hide_me('CfgNext');
show_me('CfgPrev');
break;
case 3:
break;
case 6:
alert(a.substr(1));
break;
}
} else if (b == '1') {
switch (opt) {
case 1:
set_txt('EnvBox', a.substr(1));
show_me('EnvNext');
break;
case 2:
set_txt('CfgBox', a.substr(1));
show_me('CfgNext');
hide_me('CfgPrev');
break;
case 3:
break;
case 4:
var tmp = parseInt(a.substr(1,3));
if (tmp > INSTALL_SUCCESS) INSTALL_SUCCESS = tmp;
document.getElementById('Status').innerHTML = a.substr(4);
document.getElementById('Progress').style.width = INSTALL_SUCCESS + '%';
if (INSTALL_SUCCESS >= 100) {
clearInterval(SIMPLE_INSTALL_TIMER);
clearInterval(SHOW_TIMER);
hide_me('Installing'); 
show_me('Installation');
CA_GET(5);
}
if (INSTALL_SUCCESS == 100) {
hide_me('Reconfigure'); 
hide_me('Reinstall'); 
show_me('SingIn');
} else if (INSTALL_SUCCESS == 111) {
hide_me('SingIn')
show_me('Reconfigure'); 
show_me('Reinstall'); 
INSTALL_SUCCESS = 0;
}
break;
case 5:
document.getElementById('LogBox').innerHTML = '<p class="tal">' + a.substr(1) + '</p>';
if (INSTALL_SUCCESS == 100) CA_GET(6);
break;
case 6:
alert(a.substr(1));
break;
}
} else {
if (opt > 2) {
return;
} else {
alert('Check failed, Please try again!');
}
}
}
}
} catch (e) {
console.log(e);
if (opt < 4) alert('Function CA_GET generated an error: ' + e.name + ' -> ' + e.message);
}
}
var ADMIN_EMAIL = '<?php echo (defined('ADMIN_EMAIL') ? ADMIN_EMAIL : '') ?>';
function CA_POST(opt) {
try {
switch(opt) {
case 1:
var A = ['Login Email', 'Login Password', 'Admin Timezone', 'Encode Factor', 'Domain Name', 'Host Name', 'Host Model', 'Database Host', 'Database Root Username', 'Database Root Password', 'Mail Service', 'Auto Update', 'cURL Protocol'];
break;
case 2:
var A = ['Account ID', 'License Key'];
break;
case 3:
var A = [];
break;
}
if (opt != 3 && checkNull(A) == 0) {
alert('Required fields must not be empty!');
return;
}
var c, 
a    =  '',
b    =  '',
url  =  'install.php?lan=' + LANGUAGE;
switch(opt) {
case 1:
data =  'opt='  + opt +
'&login_email='  + encodeURIComponent(document.getElementById('Login Email').value) + 
'&login_pw='   + encodeURIComponent(document.getElementById('Login Password').value) + 
'&admin_tz='  + encodeURIComponent(document.getElementById('Admin Timezone').value) + 
'&encode='  + encodeURIComponent(document.getElementById('Encode Factor').value) + 
'&domain_name='  + encodeURIComponent(document.getElementById('Domain Name').value) + 
'&host_name='    + encodeURIComponent(document.getElementById('Host Name').value) + 
'&host_model='   + encodeURIComponent(document.getElementById('Host Model').value) + 
'&db_host='   + encodeURIComponent(document.getElementById('Database Host').value) + 
'&db_root='   + encodeURIComponent(document.getElementById('Database Root Username').value) + 
'&db_pw='  + encodeURIComponent(document.getElementById('Database Root Password').value) + 
'&redis_pw='  + encodeURIComponent(document.getElementById('Redis Password').value) + 
'&mail_service=' + encodeURIComponent(document.getElementById('Mail Service').value) + 
'&auto_update='  + encodeURIComponent(document.getElementById('Auto Update').value) + 
'&protocol='   + encodeURIComponent(document.getElementById('cURL Protocol').value);
break;
case 2:
data =  'opt='  + opt +
'&account_id='  + encodeURIComponent(document.getElementById('Account ID').value) + 
'&license_key=' + encodeURIComponent(document.getElementById('License Key').value);
break;
case 3:
data =  'opt=' + opt + '&lan=' + (LANGUAGE == 'en-US' ? 0 : 1);
break;
}
if (window.XMLHttpRequest) {
c = new XMLHttpRequest();
} else {
c = new ActiveXObject('Microsoft.XMLHTTP');
}
c.open('POST', url, true);
c.setRequestHeader('Content-type', 'application/x-www-form-urlencoded; charset=utf-8');
c.send(data);
c.onreadystatechange = function() {
if (c.readyState == 4 && c.status == 200) {
a = c.responseText.replace(/(^\s*)|(\s*$)/g, '');
b = a.substr(0, 1);
if (b == '0') {
document.getElementById('errormsg').innerHTML = a.substr(1);
show_me('errormsg');
alert(a.substr(1));
} else if (b == '1') {
switch (opt) {
case 1:
ADMIN_EMAIL = document.getElementById('Login Email').value;
hide_me('Setting'); 
show_me('CheckCfg'); 
CA_GET(2);
break;
case 2:
case 3:
hide_me('Setting');
show_me('Installing');
break;
}
} else {
alert('Request failed, Please try again!');
}
}
}
} catch (e) {
console.log(e);
alert('Function CA_POST generated an error: ' + e.name + ' -> ' + e.message);
}
}
function Reinstall() {
show_me('Installing');
document.getElementById('Status').innerHTML = 'Installing...';
document.getElementById('Progress').style.width = '0%';
SIMPLE_INSTALL_TIMER = setInterval(CA_STATUS_SIMPLE, 750);
hide_me('Step0');
if (STEP != 1) hide_me('Step' + STEP);
flex_me('Step1');
SHOW_TIMER = setInterval(CA_SHOW, 10000);
CA_GET(3);
}
function Reinstall2() {
show_me('Installing');
hide_me('Step0');
if (STEP != 1) hide_me('Step' + STEP);
flex_me('Step1');
SHOW_TIMER = setInterval(CA_SHOW, 12000);
}
var SIMPE_INSTALL_TIMER = 0;
function CA_STATUS_SIMPLE () {
CA_GET(4);
}
var SHOW_TIMER = 0, STEP = 1;
function CA_SHOW() {
if (STEP >= 6) {
hide_me('Step'+STEP);
STEP = 1;
flex_me('Step'+STEP)
} else {
hide_me('Step'+STEP);
STEP++;
flex_me('Step'+STEP)
}
}
preload('logo.svg', 'install_privacy.jpg', 'install_introduction.jpg', 'install_heatmap.jpg', 'install_godview.jpg', 'install_report.jpg', 'install_security.jpg');
function preload(){
for (var i = 0; i < preload.arguments.length; i++) (new Image).src = IMGURL + preload.arguments[i];
}
var KEEP_INSTALL = <?php echo $KEEP_INSTALL ?>;
if (KEEP_INSTALL) {
hide_me('Welcome'); 
hide_me('Agreement');
Reinstall();
}
</script>
</body>
</html>